"
" $SNIFF_DIR/config/sniff.vim
"
" vimrc file for use with SNiFF+
" sourced automatically when connecting to SNiFF+
" If you want to use another file or path for your sniff mappings,
" insert the following line into your ~/.vimrc file (before 'sniff connect'):
"
"   let sniff_mappings = 'where_your_sniff_mappings_file_is'
"
" Make sure $VIM points to the directory of 
" Vim documentation (doc/) and syntax (syntax/) files.
" Otherwise online-help and syntax highlighting would not work.
"

set nocompatible	" enable additional vim features
set shortmess=rt	" truncate fileinfo msgs to one line
set mouse=a		" enable use of mouse
set hidden		" hide buffers, even if modified

" Mappings for sniff commands
" Careful! Overrides Vi 's' command
" Change to suit your needs!

map sc  :sniff connect<CR>
map sq  :sniff disconnect<CR>
map st  :sniff toggle<CR>
map sf  :sniff find-symbol<CR>
map sb  :sniff browse-class<CR>
map ss  :sniff superclass<CR>
map so  :sniff overridden<CR>
map srf :sniff retrieve-file<CR>
map srp :sniff retrieve-project<CR>
map srP :sniff retrieve-all-projects<CR>
map sR  :sniff retrieve-next<CR>
map sg  :sniff goto-symbol<CR>
map sh  :sniff hierarchy<CR>
map sH  :sniff restr-hier<CR>
map sxt :sniff xref-to<CR>
map sxb :sniff xref-by<CR>
map sxh :sniff xref-has<CR>
map sxu :sniff xref-used-by<CR>
map sd  :sniff show-docu<CR>
map sD  :sniff gen-docu<CR>

" Menus for the GUI version

if has("gui")
    500menu Sniff.Toggle\ decl/def	:sniff toggle<CR>
    500menu Sniff.Overridden\ function	:sniff overridden<CR>
    500menu Sniff.Browse\ class		:sniff browse-class<CR>
    500menu Sniff.Superclass		:sniff superclass<CR>
    500menu Sniff.Goto\ symbol		:sniff goto-symbol<CR>
    500menu Sniff.Find\ symbol		:sniff find-symbol<CR>
    500menu Sniff.Retrieve\ from\ this\ file	:sniff retrieve-file<CR>
    500menu Sniff.Retrieve\ from\ this\ project	:sniff retrieve-project<CR>
    500menu Sniff.Retrieve\ from\ all\ projects	:sniff retrieve-all-projects<CR>
    500menu Sniff.Retrieve\ (using\ Retriever\ settings) :sniff retrieve-next<CR>
    500menu Sniff.Hierarchy		:sniff hierarchy<CR>
    500menu Sniff.Restr\.\hierarchy	:sniff restr-hier<CR>
    500menu Sniff.--- :<Esc>
    500menu Sniff.Xref\ to		:sniff xref-to<CR>
    500menu Sniff.Xref\ by		:sniff xref-by<CR>
    500menu Sniff.Xref\ has		:sniff xref-has<CR>
    500menu Sniff.Xref\ used\ by	:sniff xref-used-by<CR>
    500menu Sniff.---- :<Esc>
    500menu Sniff.Show\ docu		:sniff show-docu<CR>
    500menu Sniff.Generate\ docu	:sniff gen-docu<CR>
    500menu Sniff.----- :<Esc>
    500menu Sniff.Connect		:sniff connect<CR>
    500menu Sniff.Disconnect		:sniff disconnect<CR>
endif

