#ifndef BorderItems_First
#ifdef __GNUG__
//pragma once
#pragma interface
#endif
#define BorderItems_First

#include "TextItem.h"
#include "CompVObject.h"

const int cBorderTitleGap= 4;
const int cHTitleGap    = 10;
const int cBorder       = 9,
	  cTitleGap     = 5;        // gap between titlebar and contents

//---- Matte -------------------------------------------------------------------

class Matte: public CompositeVObject {
public:
    MetaDef(Matte);

    Matte(VObject *inner);
    Matte(Point border, VObject *inner);
    Matte(int id, Point border, VObject *inner);

    Point GetBorder()
	{ return border; }
    void SetBorder(Point b);
    void SetOrigin(Point at);
    void SetExtent(Point e);
    Metric GetMinSize();
    OStream& PrintOn(OStream&);
    IStream& ReadFrom(IStream&);

protected:
    Point border;
};

//---- BorderItem -------------------------------------------------------------------

class BorderItem: public CompositeVObject {
public:
    MetaDef(BorderItem);
    BorderItem(VObject *inner);
    BorderItem(VObject *title, VObject *inner);
    BorderItem(char *title, VObject *inner);
    void SetOrigin(Point at);
    void SetExtent(Point e);
    Metric GetMinSize();
    void Draw(Rectangle r);
};

#endif

