#ifndef Box_First
#ifdef __GNUG__
//pragma once
#pragma interface
#endif
#define Box_First

#include "CompVObject.h"

struct rcinfo;

//---- Box ---------------------------------------------------------------------

class Box: public CompositeVObject {
public:
    MetaDef(Box);

    Box(int id, Point cr, Point gap, VObjAlign);
    Box(int id, Point cr, Point gap, VObjAlign, VObject*, ...);
    Box(int id, Point cr, Point gap, VObjAlign, SeqCollection*);
    Box(int id, Point cr, Point gap, VObjAlign, va_list);
    
    void SetGap(Point g);
    Point GetGap();
    void SetAlign(VObjAlign a);
    VObjAlign GetAlign();
    void SetColsRowsSize(Point cr);

    Point ColsRowsSize();
    void SetOrigin(Point at);
    void SetExtent(Point e);
    Metric GetMinSize();
    void Resize(rcinfo *rci);
    void CalcResize(int where, Point d, rcinfo *rci, rcinfo *rci2, rcinfo *rci3);
    int FindVObject(VObject *v);
    OStream& PrintOn(OStream&);
    IStream& ReadFrom(IStream&);

protected:
friend class SplitMover;
    void getGrid(Point &rc, rcinfo*, bool natural= FALSE);
    Metric getMinSize(Point &rc, rcinfo*, bool natural= FALSE);
    void expand(Point &rc, rcinfo *rci, Point &g, Point &r);

protected:
    Point gap;
    VObjAlign align;
private:
    Point colsrows;
};

inline Point Box::GetGap()
{
    return gap;
}

inline VObjAlign Box::GetAlign()
{
    return align;
}

//---- HBox --------------------------------------------------------------------

class HBox: public Box {
public:
    MetaDef(HBox);
    HBox(Point gap, VObjAlign);
    HBox(Point gap, VObjAlign, VObject*, ...);
    HBox(Point gap, VObjAlign, SeqCollection*);
    HBox(VObject*, ...);
};

//---- VBox --------------------------------------------------------------------

class VBox: public Box {
public:
    MetaDef(VBox);
    VBox(Point gap, VObjAlign);
    VBox(Point gap, VObjAlign, VObject*, ...);
    VBox(Point gap, VObjAlign, SeqCollection*);
    VBox(VObject*, ...);
};

//---- SplitHandle -------------------------------------------------------------

class SplitHandle : public VObject {
public:
    MetaDef(SplitHandle);
    SplitHandle();
    void Draw(Rectangle r);
    Metric GetMinSize();
    Command *DoLeftButtonDownCommand(Point lp, Token, int);
};

#endif

