#ifndef DictionaryHashTable_First
#ifdef __GNUG__
#pragma interface
#endif
#define DictionaryHashTable_First

#include "HashTable.h"

//---- DictionaryHashTable -----------------------------------------------------

class DictionaryHashTable : public HashTable {
public:
    MetaDef(DictionaryHashTable);
    DictionaryHashTable(int initCapacity, pEqualFunc eq, pHashFunc hash, 
			int *size= 0);
    ~DictionaryHashTable();    
    void Empty(int newCapacity);
    
    virtual void *AddAt(void *value, void *key, bool replace);
    virtual void *RemoveKey(void *key, void **value, EqualType equal);
    virtual void *AtKey(void *key, EqualType equal);
    virtual void *FindKey(void *key, void **value, EqualType equal);
    
    virtual void *ValueAt(int i);      
protected:    
    //---- table primitives
    void *KeyAt(int i);
    void SetKeyAt(void *key, int i);
    void NullAt(int i);
    void Swap(int i, int j);
    virtual void SetValueAt(void *value, int slot);
       
    void DoRehash(HashTable *ht);
    HashTable *MakeNew(int initCapacity);
    void Assign(HashTable *ht);
protected:
    Object **keys;
    Object **vals;
};

#endif /* DictionaryHashTable_First */

