#ifdef __GNUG__
#pragma implementation
#endif

#include "SortedOList.h"
#include "Class.h"

//---- SortedObjList -----------------------------------------------------------

NewMetaImpl0(SortedObjList,ObjList);

SortedObjList::SortedObjList(bool order)
{ 
    if ( order == cSortAscending )
	SetFlag(SObListAscending);
}

Object *SortedObjList::Add(Object *op)
{
    register ObjLink *lnk;
    register int comp;
    
    if ( IsArgNull("Add", op) )
	return 0;

    lnk= head->Next();
    while ( lnk != head ) {
	comp= CompareObjects(op, lnk->GetObject());
	if ( (Ascending() && comp < 0) || (! Ascending() && comp > 0) ) {
	    InsertLink(op, lnk);
	    return 0;
	}
	lnk= lnk->Next();
    }    
    ObjList::Add(op); 
    return 0;
}

Object *SortedObjList::AddFirst(Object *op)
{
    MayNotUse("AddFirst");
    return Add(op);
}

Object *SortedObjList::AddLast(Object *op)
{
    MayNotUse("AddLast");
    return Add(op);
}

Object *SortedObjList::AddBefore(Object *op, Object *)
{
    MayNotUse("AddBefore");
    return Add(op);
}

Object *SortedObjList::AddAfter(Object *op, Object *)
{
    MayNotUse("AddAfter");
    return Add(op);
}

Object *SortedObjList::AddBeforePtr(Object *op, Object *)
{
    MayNotUse("AddBeforePtr");
    return Add(op);
}

Object *SortedObjList::AddAfterPtr(Object *op, Object *)
{
    MayNotUse("AddAfterPtr");
    return Add(op);
}

Object *SortedObjList::PutAt(Object *op, int)
{
    MayNotUse("PutAt");
    return Add(op);
}

int SortedObjList::CompareObjects(Object *op1, Object *op2)
{
    return op1->Compare(op2);
}

