#ifndef Command_First
#ifdef __GNUG__
//pragma once
#pragma interface
#endif
#define Command_First

#include "Object.h"
#include "Point.h"

class Clipper;
class MacroCommand;
 
typedef enum {
    eTrackPress,
    eTrackMove,
    eTrackRelease,
    eTrackIdle,
    eTrackExit
} TrackPhase;

typedef enum {
    eCmdStateNew,
    eCmdStateDone,
    eCmdStateNotDone,
    eCmdStateFinished
} CommandState;

typedef enum {
    eCmdTypeNormal,
    eCmdTypeCantUndo,
    eCmdTypeNoChange
} CommandType;

typedef enum {
    eCmdMoveEvents   = BIT(eObjLast+1),
    eCmdIdleEvents   = BIT(eObjLast+2),
    eCmdFullScreen   = BIT(eObjLast+3),
    eCmdNoReplFeedback= BIT(eObjLast+4),
    eCmdEZScroll	 = BIT(eObjLast+5),
    eCmdDefault      = 0,
    eCmdLast         = eObjLast + 5
} CommandFlags;

class Command : public Object {
 
    friend class Clipper;
    friend class MacroCommand;
 
    int CmdNumber;
    char *CmdName;
    CommandState state;
    CommandType type;

public:
    MetaDef(Command);

    Command(int= 0, char *CmdName= 0, CommandType t= eCmdTypeNormal);
    Command(char *CmdName, CommandType t= eCmdTypeNormal);
    ~Command();

    void SetName(char *name)
	{ CmdName= name; }
    char *GetName()
	{ return CmdName; }
    char *GetUndoName();
    void SetId(int cmd)
	{ CmdNumber= cmd; }
    int GetId()
	{ return CmdNumber; }
    void SetType(CommandType t)
	{ type= t; }
    CommandType GetType()
	{ return type; }
	
    void Finish();
    int Perform();
    virtual void Done(Command *newCommand);

//protected:
    virtual void Commit();
    virtual void UndoIt();
    virtual void DoIt();
    virtual void RedoIt();
    void InspectorId(char *buf, int sz);

    virtual void TrackConstrain(Point anchorPoint, Point previousPoint, 
							    Point *nextPoint);
    virtual void TrackFeedback(Point anchorPoint, Point previousPoint,
	    bool turnItOn);

    virtual Command *TrackMouse(TrackPhase aTrackPhase, Point anchorPoint,
	    Point previousPoint, Point nextPoint);
};

extern Command *gNoChanges;
extern Command *gResetUndo;

#endif

