#ifdef __GNUG__
#  pragma implementation
#endif

#include "DirectoryDialog.h"
#include "Box.h"
#include "Buttons.h"
#include "Fields.h"
#include "Menu.h"
#include "MenuBar.h"
#include "Data.h"
#include "System.h"
#include "Class.h"

//---- DirectoryDialog ---------------------------------------------------------

NewMetaImpl0(DirectoryDialog,FileDialog);

DirectoryDialog *DirectoryDialog::gDirectoryDialog;

char *DirectoryDialog::GetDirectory(Window *w, EvtHandler *eh)
{
    if (gDirectoryDialog == 0)
	gDirectoryDialog= new DirectoryDialog;
    
    if (gDirectoryDialog->ShowInWindow(eFDRead, w, eh, "Directory Name") == cIdOk)
	return gSystem->WorkingDirectory();
    return 0;
}

DirectoryDialog::DirectoryDialog() : FileDialog("Directory Dialog")
{
}

VObject *DirectoryDialog::MakeFileItem(Data *data)
{
    VObject *item = FileDialog::MakeFileItem(data);
    if ( item != 0 && data->IsDirectory() )
	return new FileItem(data);
    return 0;
}

VObject *DirectoryDialog::MakeButtons()
{
    return
	new HBox(20, VObjAlign(eVObjVBase|eVObjHEqual|eVObjHExpand),
	    openButton = new ActionButton(cIdOk, "Open", TRUE),
	    selectButton = new ActionButton(cIdFDDirOpen, "Select"),
	    new ActionButton(cIdCancel, "Cancel"),
	    new ActionButton(cIdFDUpdate, "Update"),
	    0
	);
}

MenuBar *DirectoryDialog::DoMakeMenuBar()
{
    MenuBar *mb = new MenuBar();
    mb->AddMenu(new Menu("Directories"));
    Menu *m= new Menu("Options");
    m->AppendItems(
	"Edit Directories",	cIdFDConfDirs,
	"-",
	"Hidden Files",		cIdFDHidden,
	"Create Directory",	cIdFDMakeDir,
	0
    );
    mb->AddMenu(m);
    return mb;
}

void DirectoryDialog::DoSetup()
{
    bool have_path = (eti->GetTextSize() > 0);
    bool is_dir = FALSE;
    if ( have_path ) {
	char pathname[1024];
	eti->GetString(pathname, sizeof(pathname));
	if ( ! gSystem->ExpandPathName(pathname, sizeof(pathname)) ) {
	    FileData fd(pathname, FALSE);
	    if ( fd.IsValid() )
		is_dir = fd.IsDirectory();
	}
    }
    openButton->Enable( is_dir, TRUE );
    selectButton->Enable( !have_path || is_dir, TRUE );
}

void DirectoryDialog::Control(int id, int part, void *val)
{
    switch (id) {
    case cIdFDDirOpen:
	if ( eti->GetTextSize() == 0 )
	    eti->SetString(".");
	OpenOrChangeDir();	// MUST be a directory
	UpdateHistory(fileData->FullName());
	Dialog::Control(cIdOk, part, val);
	return;
    }
    FileDialog::Control(id, part, val);
}

bool DirectoryDialog::WrongType()
{
    return ! fileData->IsDirectory();
}
