#ifndef Env_First
#ifdef __GNUG__
//pragma once
#pragma interface
#endif
#define Env_First

#include "Object.h"
#include "Symbol.h"
#include "Rectangle.h"

enum EnvLevel {
    eEnvGlobal,
    eEnvUser,
    eEnvLocal,
    eEnvEnvironment,
    eEnvCommand,
    eEnvChange
};

//---- EnvRec ------------------------------------------------------------------

class EnvRec : public Object {
public:
    Symbol name;
    char *value, *type;
    EnvLevel level;
    bool changed;
    Object *op, **op2;
public:
    MetaDef(EnvRec);
    EnvRec(Symbol n, char *v, char *t, EnvLevel l);
    ~EnvRec();
    void ChangeValue(char *v, char *t, EnvLevel l);
    void InspectorId(char *buf, int bufSize);
    void Read(Object *op);
    void Write(Object *op);
    Object *Read2();
    void Write2(Object *op);
    int Compare(Object*);
};

//---- Env ---------------------------------------------------------------------

class Env: public Object {
    static class OrdCollection *table;
    static bool terminated;
    
public:
    MetaDef(Env);
    Env();
    ~Env();
    static void Init();
    static char *getvalue(char *name);
    static OrdCollection *GetTable()
	{ return table; }
    static bool Defined(char *name)
	{ return Env::getvalue(name) != 0; }
    static int GetValue(char *name, int dflt);
    static char *GetValue(char *name, char *dflt);
    static Rectangle GetValue(char *name, Rectangle dflt);
    static void SetValue(char *name, char *value,
				EnvLevel level= eEnvChange, char *type= 0);
    static void SetValue(char *name, EnvLevel level= eEnvChange);
    static void SetValue(char *name, int value);
    static void SetValue(char *name, double value);
    static void SetValue(char *name, Rectangle);
    static void SetBoolValue(char *name, bool value);
    static void Save();
    static EnvRec *Lookup(char *n);
    static void ReadFile(char *fname, EnvLevel level);
    static bool Bind(Object *&op, char *name);
};

#endif
