#ifdef __GNUG__
#pragma implementation
#endif

#include "EvtHandler.h"

#include "Class.h"
#include "Command.h"
#include "CommandProcessor.h"

static CommandProcessor *cmdp = 0;

//---- EvtHandler --------------------------------------------------------------

NewAbstractMetaImpl(EvtHandler, Object, (T(id)));

EvtHandler::EvtHandler()
{
}
    
EvtHandler *EvtHandler::GetNextHandler()
{
    return 0;
}

EvtHandler *EvtHandler::FindNextHandlerOfClass(Class *cla)
{
    EvtHandler *eh;
    for (eh = this; eh != 0; eh = eh->GetNextHandler())
	if (eh->IsA()->isKindOf(cla))
	    return eh;
    return 0;
}

//---- menus -------------------------------------------------------------------

Menu *EvtHandler::GetMenu()
{
    EvtHandler *eh = GetNextHandler();
    if (eh)
	return eh->GetMenu();
    return 0;
}

void EvtHandler::DoSetupMenu(Menu *mp)
{
    EvtHandler *eh = GetNextHandler();
    if (eh)
	eh->DoSetupMenu(mp);
    else {
	if (cmdp == 0)
	    cmdp = new CommandProcessor;
	cmdp->DoSetupMenu(mp);
    }
}

Command *EvtHandler::DoMenuCommand(int cmd)
{
    EvtHandler *eh = GetNextHandler();
    if (eh)
	return eh->DoMenuCommand(cmd);
    return gNoChanges;
}

void EvtHandler::PerformCommand(Command *cmd)
{
    if (cmd && cmd != gNoChanges) {
	EvtHandler *eh = GetNextHandler();
	if (eh)
	    eh->PerformCommand(cmd);
	else {
	    if (cmdp == 0)
		cmdp = new CommandProcessor;
	    cmdp->PerformCommand(cmd);
	}
    }
}

//---- firsthandler --------------------------------------------------------

bool EvtHandler::SetFirstHandler(EvtHandler *fh)
{
    EvtHandler *eh = GetNextHandler();
    if (eh)
	return eh->SetFirstHandler(fh);
    return TRUE;
}

bool EvtHandler::KbdFocus(bool)
{
    return TRUE;
}

//---- input distribution --------------------------------------------------

Command *EvtHandler::Input(Point, Token&, Clipper*)
{
    return gNoChanges;
}

void EvtHandler::SendDown(int, int, void*)
{
}

void EvtHandler::ExtCommand(int from, char *req, char *args, int len,
			    char *&ret, int &retlen)
{
    EvtHandler *eh = GetNextHandler();
    if (eh)
	eh->ExtCommand(from, req, args, len, ret, retlen);
}

void EvtHandler::InputKbd(Token&)
{
}

void EvtHandler::Send(int id, int part, void *val)
{
    Object::Send(id, part, val);
    EvtHandler *eh = GetNextHandler();
    if (eh)
	eh->Control(id, part, val);
}

//---- misc --------------------------------------------------------------------

void EvtHandler::Control(int id, int part, void *val)
{
    EvtHandler *eh = GetNextHandler();
    if (eh)
	eh->Control(id, part, val);
}

Command *EvtHandler::DoIdleCommand()
{
    EvtHandler *eh = GetNextHandler();
    if (eh)
	return eh->DoIdleCommand();
    return gNoChanges;
}

//---- input/output ------------------------------------------------------------

OStream& EvtHandler::PrintOn(OStream &s)
{
    Object::PrintOn(s);
    return s << id SP;
}

IStream& EvtHandler::ReadFrom(IStream &s)
{
    Object::ReadFrom(s);
    return s >> id;
}
