#ifdef __GNUG__
#pragma implementation
#endif

#include "Filler.h"

#include "Class.h"

//---- Filler ------------------------------------------------------------------

NewMetaImpl(Filler,VObject, (T(minsize), TP(ink)));

Filler::Filler(Point extent, int flags)
{   
    ink= gInkNone;
    contentRect.extent= minsize= extent;
    SetFlag(flags & (eVObjHFixed | eVObjVFixed));
}

Filler::Filler(Point extent, Ink *ik, int flags)
{   
    ink= ik;
    contentRect.extent= minsize= extent;
    SetFlag(flags & (eVObjHFixed | eVObjVFixed));
}

Metric Filler::GetMinSize()
{
    return Metric(minsize);
}

void Filler::Draw(Rectangle r)
{
    if (ink != ePatNone)
	GrPaintRect(r, ink);
}

Ink *Filler::SetInk(Ink *ik, bool redraw)
{
    Ink *oldink= ink;
    ink= ik;
    if (redraw)
	ForceRedraw();
    return oldink;
}

OStream& Filler::PrintOn(OStream &s)
{
    VObject::PrintOn(s);
    return s << minsize SP << ink SP;
}

IStream& Filler::ReadFrom(IStream &s)
{
    VObject::ReadFrom(s);
    return s >> minsize >> ink;
}

