#ifdef __GNUG__
#pragma implementation
#endif

#include "FindChange_e.h"

#include "Class.h"
#include "Application.h"
#include "FindDialog.h"
#include "TextView.h"
#include "MenuBar.h"
#include "Menu.h"

FindDialog *FindChange::findDialog = 0;

void FindChange::ShowFindDialog(TextView *tv)
{
    if (findDialog == 0)
    {
	findDialog= new FindDialog("Find/Change");
	gApplication->AddManager(findDialog);
	findDialog->SetTextViewFocus(tv);
	findDialog->ShowUnderMouse();
    }
    else
    {
	findDialog->SetTextViewFocus(tv);
	findDialog->ShowAt(NULL, findDialog->GetWindow()->GetRect().origin);
    }
}

void FindChange::HideFindDialog(TextView *tv)
{
    if (findDialog == 0) 
        return;
    if (tv == 0 || tv == findDialog->GetTextViewFocus())
        findDialog->Hide();
}

void FindChange::FindAgain(TextView *tv)
{
    if (findDialog != 0) {
	findDialog->SetTextViewFocus(tv);
        findDialog->FindAgain();
    }
}

void FindChange::DoSetupMenu(Menu *menu)
{
    char *pattern = 0;
    if (findDialog != 0)
        pattern = findDialog->GetSearchPattern();
    menu->EnableItem(cFINDAGAIN, (pattern != 0 && pattern[0] != 0));
}

void FindChange::InstallFind(MenuBar *mb, TextView *tv)
{
    Menu *m= mb->FindMenu(cEDITMENU);  
    if (m) 
	m->InsertItemsAfter(cLASTEDIT, "Find/Change...@F",  cFIND, 
                                       "Find Again @G", cFINDAGAIN,
                           0);
    if (tv)
	tv->SetFlag(eTextWantFindFocus);
}

void FindChange::SetFocus(TextView *tv)
{
    if (tv->TestFlag(eTextWantFindFocus)) {
	if (findDialog != 0)
	    findDialog->SetTextViewFocus(tv);
    }
}


// obsolete

void FindChange::ShowChangeDialog(TextView *tv)
{
    FindChange::ShowFindDialog(tv);
}

void FindChange::HideChangeDialog(TextView *tv)
{
    FindChange::HideFindDialog(tv);
}

void FindChange::InstallChange(MenuBar *mb, TextView *tv)
{
    FindChange::InstallFind(mb, tv);
}
