#ifndef _FindDialog_h_
#define _FindDialog_h_

#ifdef __GNUG__
#  pragma interface
#endif

#include "Dialog.h"

class RegularExp;
class TextView;
class TextField;
class OneOfCluster;
class ManyOfCluster;
class VObject;

//---- FindDialog -----------------------------------------------------------

class FindDialog : public Dialog {
public:
    MetaDef(FindDialog);
    FindDialog(char *title);
    ~FindDialog();

    TextView *GetTextViewFocus()
	{ return tvp; }
    void SetTextViewFocus(TextView *);
    char *GetSearchPattern();

    bool Find(char *find_str, bool forward);
    void FindAgain();
    int  ChangeAll(int from, int to, char *find, char *change,
		int& last_from, int& last_to);

    virtual bool DoFind(char *str, bool forward, bool msg= TRUE);
    virtual void DoChange(char *pat, char*);
    virtual void DoChangeAll(char *pat, char*);

protected:
    VObject *DoMakeContent();
    void DoSetup();
    void DoSetDefaults();
    void Control(int, int, void *);
    void SendDown(int, int, void *);
    void DoObserve (int id, int part, void *val, Object *op);
    bool Compile(char *pattern);
    void ShowMessage(char *, bool bell = TRUE);
    virtual void RevealSelection();

protected:
    RegularExp *rex;
    TextView *tvp;
    TextField *ei1;
    TextField *ei2;
    TextField *msg_field;
    OneOfCluster *modecl;
    ManyOfCluster *optionscl;
    OneOfCluster *scopecl;
    VObject *next;
    VObject *change;
    VObject *changeAndFind;
    VObject *changeAll;
    bool atBegin, atEnd;
};

#endif
