#ifdef __GNUG__
#pragma implementation
#endif

#include "GotoDialog.h"

#include "Class.h"
#include "Dialog.h"
#include "Window.h"
#include "Fields.h"
#include "TextView.h"
#include "BorderItems.h"
#include "Buttons.h"
#include "Document.h"
#include "WindowSystem.h"
#include "ObjectTable.h"
#include "Expander.h"
#include "ETMath.h"

static GotoDialog *gotoDialog;

//---- entry Point -------------------------------------------------------------

void GotoLine(TextView *tv)
{
    if (gotoDialog == 0)
	gotoDialog= new GotoDialog;
    gotoDialog->ShowGotoDialog(tv);
}

//---- GotoDialog --------------------------------------------------------------

NewMetaImpl(GotoDialog, Dialog, (TP(view), TP(line), TP(gotoDialog)));

GotoDialog::GotoDialog() : Dialog("Goto")
{
    line= 0;
}

void GotoDialog::ShowGotoDialog(TextView *v)
{
    if (v) 
    	{
		view= v;
		if (ShowUnderMouse() == cIdYes) 
			{
		    int at= line->GetValue();
		    int	pos, end;
		    view->GetRealLinePos(at, &pos, &end);
		    view->SetSelection(pos, end, TRUE);
		    view->RevealSelection();
			}
    	}
}
 
VObject *GotoDialog::DoMakeContent()
{
    return
	new Matte(10, 
	    new VExpander(20,
		new HBox(10, (VObjAlign)(eVObjVBase|eVObjHExpand),
		    new TextItem("Go to line:"),
		    line= new IntField(cIdNone),
		    0
		),
		new HBox(20, (VObjAlign)(eVObjVBase|eVObjHEqual|eVObjHExpand),
		    new ActionButton(cIdYes,    "Go to", TRUE),
		    new ActionButton(cIdCancel, "Cancel"),
		    0
		),
		0
	    )
	);
}

void GotoDialog::DoSetDefaults()
{
    int f, t;
    int currLine;
    int nLines = view->NumberOfLines();

    view->GetSelection(&f, &t);
    currLine = view->CharToLine(f);

    line->SetValue(view->RealToLogicalLine(currLine) + 1);
    line->SetRange(1, Math::Max(1, view->RealToLogicalLine(nLines)));
}
