//-*-Mode: C++;-*-
#ifndef _HelpHandler_h_
#define _HelpHandler_h_

#if __GNUG__ >= 2
#  pragma interface
#endif

#include "RefCounted.h"
#include "Port.h"

class EvtHandler;

//---- HelpHandler -----------------------------------------------------------
// This is a generic help class by Michael Scharf (Jan. 1996).
// ET++ has been patched at several places to support help.

class HelpHandler : public RefCounted
{
public:
    MetaDef(HelpHandler);
    HelpHandler();

    static void Init();
	// IMPORTANT Init *must* be called in the ET++ initialisation!!!
    static void SetHandler(HelpHandler*help);

    virtual bool Help(Object* vop);
	// return TRUE if help is enabled

    virtual void StartContextHelp();
    virtual bool InContextHelp();
    virtual void EndContextHelp();
    virtual bool HelpOnMenu(EvtHandler*firstHandler,int cmd);
	// return TRUE if help is enabled
protected:
    //--- Methods concrete super classes should overwrite:
    virtual void DoHelp(Object* object);
	// Calls ShowHelp(MakeHelpString(object))
    virtual void ShowHelp(const char*);
	// implements the showing of Help
    virtual const char* MakeHelpString(Object* object);
	// creates a help string (or key) to be passed to ShowHelp
    virtual bool IsHelpEnabled();
	// Overwrite to enable help. Default is return FALSE
protected:
    int fInContextHelp;
};

extern HelpHandler* gHelp; //readonly!!

#endif
