#ifdef __GNUG__
#pragma implementation
#endif

#include "ImageItem.h"

#include "Class.h"
#include "Look.h"

//---- ImageItem ---------------------------------------------------------------

NewMetaImpl(ImageItem,VObject, (TP(bmp), T(base), TB(deleteBitmap)));

ImageItem::ImageItem(Bitmap *b, int bs, bool freeold)
{
    deleteBitmap= freeold;
    base= bs;
    bmp= b;
    SetFlag(eVObjHFixed | eVObjVFixed);
}

ImageItem::ImageItem(int id, Bitmap *b, int bs, bool freeold) : VObject(id)
{
    deleteBitmap= freeold;
    base= bs;
    bmp= b;
    SetFlag(eVObjHFixed | eVObjVFixed);
}

ImageItem::ImageItem(short *s, Point e, int bs)
{
    deleteBitmap= TRUE;
    base= bs;
    bmp= new Bitmap(e, (u_short*)s);
    SetFlag(eVObjHFixed | eVObjVFixed);
}

ImageItem::~ImageItem()
{
    if (deleteBitmap) {
	SafeDelete(bmp);
    }
    
}

void ImageItem::SetBitmap(Bitmap *bm, bool redraw)
{
    if (deleteBitmap && bmp)
	delete bmp;
    deleteBitmap= FALSE;
    bmp= bm;
    SetContentRect(Rectangle(GetOrigin(), GetMinSize().extent), redraw);
}

Metric ImageItem::GetMinSize()
{
    return Metric(bmp->Size(), base ? base : bmp->Size().y);
}

void ImageItem::Draw(Rectangle)
{
    GrPaintBitMap(contentRect, bmp, Enabled() ? ePatBlack : gLook->DisableInk());
}

void ImageItem::DoObserve(int, int part, void*, Object *op)
{
    if (op == bmp && part != cPartSenderDied)
	ForceRedraw();
}

OStream& ImageItem::PrintOn (OStream &s)
{
    VObject::PrintOn(s);
    return s << bmp SP << base SP;
}

IStream& ImageItem::ReadFrom(IStream &s)
{
    if (deleteBitmap)
	SafeDelete(bmp);
    deleteBitmap= TRUE;
    VObject::ReadFrom(s);
    return s >> bmp >> base;
}

