#ifndef _Invariant_h_
#define _Invariant_h_

#ifdef __GNUG__
#pragma interface
#endif

#include "Types.h"
#include "Error.h"

//--------------------------------------------------------------------------

#ifdef USE_INVARIANT

#  define InvariantChecker(name)                \
class _NAME2_(name,InvChecker) {                \
    name *obj;                                  \
public:                                         \
    _NAME2_(name,InvChecker)(name *o)           \
	{  obj= o; obj->CheckInvariant(); }     \
    ~_NAME2_(name,InvChecker)()                 \
	{  obj->CheckInvariant(); }             \
}                                                            

#  define AssertInvariant(name)                 \
    _NAME2_(name,InvChecker)  __checkInv(this)                        

#  define Assert(expr)                                                \
    ((expr) ?                                                         \
	1 :                                                           \
	(Fatal("", _QUOTE_(expr) " violated at line %d of `%s'.\n",   \
	       __LINE__, __FILE__),                                   \
	0))

#else
 
#  define InvariantChecker(name)
#  define AssertInvariant(name)
#  define Assert(expr)

#endif /* USE_INVARIANT */

//-------------------------------------------------------------------------

#endif /* _Invariant_h_ */
