#ifndef MacroCommand_First
#ifdef __GNUG__
#pragma interface
#endif
#define MacroCommand_First

#include "Command.h"

class SeqCollection;
//---- MacroCommand -----------------------------------------------
class MacroCommand: public Command {
protected:
    SeqCollection *commands;
    Command *lastCmd;
public:
    MetaDef(MacroCommand);
    MacroCommand(char*name);
    ~MacroCommand();
    virtual void Add(Command*);
    int Size();
    void Cancel(); // Undo everything and finish the commands.
protected:
    void Done(Command *newCommand);
    void Commit();
    void UndoIt();
    void DoIt();
    void RedoIt();
};

//---- GrMacroCommand -----------------------------------------------
// GrMacroCommand calls gWindowSystem->{Begin,End}Update

class GrMacroCommand: public MacroCommand {
protected:
    bool grUpdate;
public:
    MetaDef(GrMacroCommand);
    GrMacroCommand(char*name);
    ~GrMacroCommand();
    void Add(Command*);
protected:
    void UndoIt();
    void DoIt();
    void RedoIt();
    
    // can be called in any order...
    void BeginDelayUpdate();
    void EndDelayUpdate();
};
#endif /* MacroCommand_First */

