#ifdef __GNUG__
#pragma implementation
#endif

#include "ManyOfCluster.h"

#include "Class.h"
#include "Buttons.h"
#include "OrdColl.h"

//---- ManyOfCluster -----------------------------------------------------------

NewMetaImpl0(ManyOfCluster,Cluster);

ManyOfCluster::ManyOfCluster(int id, VObjAlign a, Point g, SeqCollection *cp)
						: Cluster(id, a, g, cp)
{
    SetFlag(eVObjVFixed);
}

ManyOfCluster::ManyOfCluster(int id, VObjAlign a, Point g, VObject *va_(vop), ...)
						: Cluster(id, a, g)
{
    va_list ap;
    va_start(ap,va_(vop));
    SetItems(va_(vop), ap);
    va_end(ap);
}

ManyOfCluster::ManyOfCluster(int id, VObject *va_(vop), ...) : Cluster(id, eVObjHLeft)
{
    va_list ap;
    va_start(ap,va_(vop));
    SetItems(va_(vop), ap);
    va_end(ap);
}

ManyOfCluster::ManyOfCluster(int id, VObjAlign a, Point g, char *va_(cp), ...)
						: Cluster(id, a, g)
{
    char *t;
    va_list ap;
    va_start(ap,va_(cp));
    
    Add(new ToggleButton(id+0, va_(cp)));
    for (int i= 1; t= va_arg(ap, char*); i++)
	Add(new ToggleButton(id+i, t));
    va_end(ap);
}

ManyOfCluster::ManyOfCluster(int id, char *va_(cp), ...) : Cluster(id, eVObjHLeft)
{
    char *t;
    va_list ap;
    va_start(ap,va_(cp));

    Add(new ToggleButton(id+0, va_(cp)));
    for (int i= 1; t= va_arg(ap, char*); i++)
	Add(new ToggleButton(id+i, t));
    va_end(ap);
}

void ManyOfCluster::Control(int id, int p, void *v)
{
    if (p == cPartToggle)
	Cluster::Control(GetId(), id, v);
}

void ManyOfCluster::SetItem(int id, bool state)
{
    Iter next(MakeIterator());
    register VObject *dip;

    while (dip= (VObject*) next())
	if (dip->IsKindOf(StateButton) && dip->GetId() == id) {
	    ((StateButton*)dip)->SetValue(state ? 1 : 0);
	    break;
	}
}
    
void ManyOfCluster::SetAllItems(bool state)
{
    Iter next(MakeIterator());
    register VObject *dip;

    while (dip= (VObject*) next())
	if (dip->IsKindOf(StateButton))
	    ((StateButton*)dip)->SetValue(state ? 1 : 0);
}
    
bool ManyOfCluster::IsItemOn(int id)
{
    Iter next(MakeIterator());
    register VObject *dip;

    while (dip= (VObject*) next())
	if (dip->IsKindOf(StateButton) && dip->GetId() == id)
	    return ((StateButton*)dip)->GetValue() != 0;
    return FALSE;
}

