#ifdef __GNUG__
#pragma implementation
#endif

#include "Class.h"
#include "Bitmap.h"
#include "Env.h"
#include "WindowSystem.h"

#include "MarkerItem.h"

//---- marker item image

static u_short markerBits[]= {
#   include "images/marker.image"
};
SmartBitmap markerBitmap(Point(7, 4), markerBits);
static Ink *markerInk= 0;

//---- ChangeMarkerCommand ----------------------------------------------

ChangeMarkerCommand::ChangeMarkerCommand(
    char *cmd, int cmdNo, MarkerItem *mi, char *nn, char *nt
) : Command(cmdNo, cmd)
{
    oldName= 0;
    newName= strsave(nn);
    newType= strsave(nt);
    item= mi;
}

ChangeMarkerCommand::~ChangeMarkerCommand()
{ 
    SafeDelete(newName);
    SafeDelete(oldName);
    SafeDelete(newType);
    SafeDelete(oldType);
}

void ChangeMarkerCommand::DoIt()
{
    if (oldName == 0) {
	oldName= strsave(item->Name());
	oldType= strsave(item->Type());
    }
    item->SetName(newName);
}

void ChangeMarkerCommand::UndoIt()
{
    item->SetName(oldName);
}

//---- class MarkerItem ---------------------------------------------------

NewMetaImpl(MarkerItem,VisualMark, (TS(name)));

MarkerItem::MarkerItem(char *n, char *t)
{
    name= 0;
    strreplace(&name, n);
    type= 0;
    strreplace(&type, t);
}

MarkerItem::~MarkerItem()
{
    SafeDelete(name);
    SafeDelete(type);
}

void MarkerItem::Draw(Point p, Rectangle, Rectangle lr, bool b)
{
    if (markerInk == 0)
	if (gColor) {
	    markerInk= new_RGBColor(0, 0, 255);
	    //Env::Bind(linkInk, "Write.MarkerColor");
	} else
	    markerInk= gInkBlack;
	if (b) {
	    Rectangle r(p.x-4, lr.origin.y, 7, 4);
	    GrPaintBitMap(r, markerBitmap, markerInk);
	    p.x--;
	    //GrPaintLine(markerInk, 0, eDefaultCap, p, Point(p.x, p.y-4));
	}
}

OStream& MarkerItem::PrintOn (OStream& o)
{
    VisualMark::PrintOn(o);
    o.PrintString(name);  
    return o.PrintString(type);
}

IStream& MarkerItem::ReadFrom(IStream& i)
{
    VisualMark::ReadFrom(i);
    SafeDelete(name);
    SafeDelete(type);
    i.ReadString(&name);
    return i.ReadString(&type);
}

void MarkerItem::SetName(char *nm)
{
    strreplace(&name, nm);
}

void MarkerItem::SetType(char *t)
{
    strreplace(&type, t);
}
