#ifndef MarkerItem_First
#define MarkerItem_First
#ifdef __GNUG__
#pragma interface
#endif

#include "VObject.h"
#include "Text.h"
#include "Command.h"

//---- MarkerItem -------------------------------------------------------------

class MarkerItem : public VisualMark {
public:
    MetaDef(MarkerItem);
    MarkerItem(char *name, char *type);
    ~MarkerItem();

    void Draw(Point p, Rectangle clip, Rectangle lr, bool border);

    char *Name()
    	{ return name; }
    char *Type()
    	{ return type; }
    void SetName(char *name);
    void SetType(char *type);
    
    //---- printing
    OStream& PrintOn(OStream&);
    IStream& ReadFrom(IStream&);
private:
    char *name;
    char *type;
};

//---- ChangeMarkerCommand ----------------------------------------------

class ChangeMarkerCommand: public Command {
    MarkerItem *item;
    char *newName;
    char *oldName;
    char *newType;
    char *oldType;
public:
    ChangeMarkerCommand(char *cmd, int cmdNo, MarkerItem *item, char *newName, char *newType);
    ~ChangeMarkerCommand();
    void DoIt();
    void UndoIt();
};

#endif
