#ifndef Inspector_First
#ifdef __GNUG__
//pragma once
#pragma interface
#endif
#define Inspector_First

#include "CollView.h"
#include "EtPeTool.h"

class PeClassListView;
class PeFindInspReferences;
class SysEvtHandler;
class PeObjectView;
class OrdCollection;
class Ref;
class Class;
class TextField;

//---- PeInspector -------------------------------------------------------------

class PeInspector: public EtPeTool {
    static PeInspector *inspector;
    static int inspcnt;
    static OrdCollection *allInspectors;
    
    CollectionView *objects, *references;
    PeClassListView *classes;
    OrdCollection *classItems;
    SeqCollection *objectItems, *referenceItems;
    TextField *refTitle, *objTitle; 
    VObject *start, *left, *right, *end;   
    Object *currentOp;
    PeFindInspReferences *findReferences;
    SysEvtHandler *refresh;
    PeObjectView *objView;
    OrdCollection *path;
    int position;

public:
    MetaDef(PeInspector);
    PeInspector(Manager *m);
    ~PeInspector();
    
    VObject *DoMakeContent();
    MenuBar *DoMakeMenuBar();
    
    void Init(Object *op);
    void LoadObjectsOfClass(Class *, bool members);
    void Member(int mode, char *name, int offset, int size= 0);
    void References(Object*);
//begin INSPECT_OBSERVERS (Michael Scharf Fri Jan  5 1996)
    void DoesObserve(Object*);
    void ObservedBy(Object*);
    void ObserverFound(Object*);
//end INSPECT_OBSERVERS (Michael Scharf Fri Jan  5 1996)
    void Reset();
    void ResetReferences();
    void FoundReference(Object *op, char *name, int index= -1);
    void ResetObjects();
    void FreedMemory(void *addr, void *end);
    void DoInspect(Object *);
    
    void MoveTo(int pos);
    void Push(Ref *r);
    void ShowReference(Ref *);
    void ShowClass(Class *cl);
    void ShowObject(Object *op);
    void SelectAndRevealItem(CollectionView *cv, int at);

    //---- menus ------------
    void Control(int id, int, void *v);
    void DoSetupMenu(Menu *menu);
    Command *DoMenuCommand(int cmd);
    void UpdateButtons();

    //---- commands ---------
    void ShowAllInstances();
    
    friend void InspectorFreeHook(void *, void *, size_t);
    void RemoveDeletedRef(int i, Ref *r);

    static void Spawn(Manager *m, Ref *ref, bool block);
    static void ShowObject(Manager *m, Object *op, bool block);
};

#endif
