#ifndef PictPort_First
#ifdef __GNUG__
//pragma once
#pragma interface
#endif
#define PictPort_First

#include "PrintPort.h"
#include "MemBuf.h"

class PictPort: public PrintPort {    
protected:
    class MemBuf *pagebuf;
    Point lastpos, lastdia, lastextent;
    Font *lastfont;
    int lastpsz, laststartangle, lastendangle;
    GrLineCap lastcap;
    Ink *lastink2;
    ObjArray *map;

    class Picture *pict;

    void PutByte(byte b)
	{ pagebuf->sputc(b); }
    void PutCode(int c)
	{ PutByte(c); }
    void PutChar(char c)
	{ pagebuf->sputc(c); }
    void PutShort(short s);
    void PutInt(int i);
    void PutPoint(byte code, Point p);
    void PutPos(Point pos);
    void PutRect(Rectangle *r);
    void PutSize(int s);
    void PutCap(GrLineCap cap);
    void PutAngle(int s, int e);
    void PutDia(Point e);
    void PutInk();

public:
    MetaDef(PictPort);
    PictPort(Picture*);
    ~PictPort();
    
    Picture *GetPicture()
	{ return pict; }
    void DevOpenPage(int n);
    void DevClosePage();
    void DevClip(Rectangle*);
    void DevStrokeLine(int, Rectangle*, GrLineCap, Point, Point);
    void DevShowChar(Font *fdp, Point delta, byte c, Rectangle*);
    void DevStrokeRect(int, Rectangle*);
    void DevFillRect(Rectangle*);
    void DevStrokeOval(int, Rectangle*);
    void DevFillOval(Rectangle*);
    void DevStrokeRRect(int, Rectangle*, Point);
    void DevFillRRect(Rectangle*, Point);
    void DevStrokeWedge(int, GrLineCap, Rectangle*, int, int);
    void DevFillWedge(Rectangle*, int, int);
    void DevStrokePolygon(Rectangle*, Point*, int, GrPolyType t, int, GrLineCap);
    void DevFillPolygon(Rectangle*, Point*, int, GrPolyType t);
    void DevShowBitmap(Rectangle*, class Bitmap*);
    void DevShowPicture(Rectangle *r, Picture *pict);
    void DevGiveHint(int code, int len, void *vp);
};

#endif
