#ifndef Scroller_First
#ifdef __GNUG__
//pragma once
#pragma interface
#endif
#define Scroller_First

#include "Cluster.h"

class ScrollBar;
class Clipper;

typedef enum ScrollDir {
    eScrollNone       = 0,
    eScrollRight      = BIT(0),
    eScrollDown       = BIT(1),
    eScrollLeft       = BIT(2),
    eScrollUp         = BIT(3),
    eScrollHideScrolls= BIT(4),
    eScrollDefault    = eScrollRight | eScrollDown
} ScrollDir;

const int cScrollBarSize= 20;

class Scroller: public CompositeVObject {
public:
    MetaDef(Scroller);
    Scroller (VObject *v= 0, Point e= gPoint0, int id= cIdNone,
	      ScrollDir= (ScrollDir)(eScrollDefault|eScrollHideScrolls));
    Scroller (VObject *v, Ink *bg, Point e= gPoint0, int id= cIdNone,
	      ScrollDir= (ScrollDir)(eScrollDefault|eScrollHideScrolls));

    Clipper *GetClipper();
    ScrollBar *GetScrollBar(int i);

    void Open(bool);
    void Draw(Rectangle);
    void Control(int, int, void*);

    void SetBgInk(Ink *);
    Ink *GetBgInk();

    void SetExtent(Point e);
    void SetOrigin(Point at);

    Metric GetMinSize();
    void ViewSizeChanged();
    bool NeedControls(Point e, Point vs);
    void BubbleUpdate(Point bs);

    Command *Input(Point lp, Token &t, Clipper *vf);
    Command *DoOtherFunctionKeyCommand(int, Token);

    OStream& PrintOn(OStream&);
    IStream& ReadFrom(IStream&);

protected:
    virtual Clipper *MakeClipper();
    virtual ScrollBar *MakeScrollBar(int id);

protected:
    ScrollBar *sb[4];
    Clipper *vf;
    VObject *vop;
    Point ms;
    ScrollDir controls, visibleControls;
};

#endif
