#if defined(__GNUG__) && __GNUG__ >= 2
#  pragma implementation
#endif

#include "StringInputDiag.h"
#include "Class.h"
#include "TextItem.h"
#include "TextView.h"
#include "Filler.h"
#include "Window.h"
#include "Expander.h"
#include "Box.h"
#include "BorderItems.h"
#include "Buttons.h"
#include "Fields.h"

NewMetaImpl(StringInputDiag, Dialog, (TP(pattern), 0));

StringInputDiag::StringInputDiag(char *windowTitle, char *stringDesc,
		char *initStr): Dialog(windowTitle)
{
	pattern= new TextField(cIdNone,40);
	pattern->SetString(initStr);
	desc= strsave(stringDesc);
	init= strsave(initStr);
}

StringInputDiag::~StringInputDiag()
{
	SafeDelete(desc);
	SafeDelete(init);
}

VObject *StringInputDiag::DoMakeContent()
{
	return
		new VBox(5, eVObjHCenter,
			new HBox(4, eVObjVBase,
					new TextItem(desc),
					pattern,
					0
			),
			new HBox(5, eVObjVBase,
				new ActionButton(cIdOk,"Ok",TRUE),
				new ActionButton(cIdCancel,"Cancel"),
				Hook(),
				0
			),
			0
		);
}

VObject *StringInputDiag::Hook()
{
	return 0;
}

char * StringInputDiag::GetString()
{
	return pattern->AsString();
}

void StringInputDiag::SetString(char *str)
{
	pattern->SetString(str);
}
