#ifndef TextItem_First
#ifdef __GNUG__
//pragma once
#pragma interface
#endif
#define TextItem_First

#include "VObject.h"

//---- TextItem ----------------------------------------------------------------

class TextItem : public VObject {
protected:
    char *text;
    Font *font;
    Point border;

public:
    MetaDef(TextItem);

    TextItem(char *t, Font *f= gSysFont, Point b= gBorder);
    TextItem(int id, char *t, Font *f= gSysFont, Point b= gBorder);
    ~TextItem();

    void SetString(char*, bool redraw= FALSE);
    void SetFString(bool redraw, char *fmt, ...);
    void SetBorder(Point b)
	{ border= b; }
    Metric GetMinSize();
    void SetExtent(Point e);
    Font *GetFont()
	{ return font; }
    void SetFont(Font *fp);
    void Draw(Rectangle);
    char *AsString();
    int Compare(Object *op);
    bool IsEqual(Object *op);
    OStream& PrintOn(OStream&);
    IStream& ReadFrom(IStream&);
};

#endif

