#ifndef TextMarker_First
#ifdef __GNUG__
//pragma once
#pragma interface
#endif
#define TextMarker_First

#include "Text.h"

class VObject;
class Data;
//------ VObjectMark -----------------------------------------------------------
// a mark managing a VObject

class VObjectMark: public VisualMark {
protected:
    VObject *vop;
public:
    MetaDef(VObjectMark);
    
    VObjectMark(VObject *vo= 0);
    ~VObjectMark();

    VObject *GetVObject();

    void CalcExtent();
    Point GetExtent();
    int Base();
    void SetContainer(class VObject*);
    void Draw(Point at, Rectangle clip, Rectangle line, bool border);
    void SendDown(int, int, void *);
    bool WantsInput(Point p);
    virtual class Command *Input(Point lp, Token &t, class Clipper *cl);

    void FreeAll();
    OStream& PrintOn(OStream&);
    IStream& ReadFrom(IStream&);
    void CollectParts(Collection *col);
}
;
//---- VObjectMark --------------------------------------------------

inline VObject* VObjectMark::GetVObject()
{ 
    return vop; 
}

//---- ReferenceMark ------------------------------------------------------
//     a Reference to a graphical object stored in a file
//     the image is loaded on demand

class ReferenceMark: public VisualMark {
public:
    MetaDef(ReferenceMark);
    
    ReferenceMark(char *filename, Point sizeHint= gPoint_1);
    ~ReferenceMark();

    VObject *GetVObject();
    char *FileName();
    void SetFileName(char *fn);
    void SetExtentHint(Point p);
    
    // vobject protocol
    Point GetExtent();
    int Base();
    void SetContainer(class VObject*);
    void Draw(Point at, Rectangle clip, Rectangle line, bool border);
    void SendDown(int, int, void *);
    bool WantsInput(Point p);
    virtual class Command *Input(Point lp, Token &t, class Clipper *cl);

    // object protocol
    void FreeAll();
    OStream& PrintOn(OStream&);
    IStream& ReadFrom(IStream&);
    void CollectParts(Collection *col);

protected:
    virtual void Load();
    virtual VObject* Convert(Data*);
    virtual char *AskUser();
    virtual void VerifyFileName();
    virtual void SetupDocPath();
    virtual VObject* MakePlaceHolder(); //instead of the real thing
protected:
    VObject *vop;
    VObject *container;
    char *filename;
    Point sizeHint;
    bool verify;
};


#endif

