#ifdef __GNUG__
#pragma implementation
#endif

#include "Token.h"

#include "ETMath.h"
#include "ETString.h"
#include "ETCType.h"

int gDoubleClickTime = 500;  // 0.5 sec

Token::Token()
{
    Code= eEvtNone;
    Flags= eFlgNone;
}

Token::Token(EventCodes ec, EventFlags f, Point p)
{
    Code= ec;
    Flags= f;
    Pos= p;
}

bool Token::DoubleClick(Token &t)
{
    int t1= t.Pos.x-Pos.x, t2= t.Pos.y-Pos.y;
    long t3= t.At-At;
    if (t.IsMouseButton())
	if (t.Code == Code && Math::Abs(t1) < 2 && Math::Abs(t2) < 2
			     && Math::Abs(t3) < gDoubleClickTime)
	    return TRUE;
    return FALSE;
}

char Token::MapToAscii()
{
    return Isupper(Code) ? (Code + 0x20) : Code;
//    return (Code & 0x7f) + 0x60;
}

Point Token::CursorPoint()
{
    switch (CursorDir()) {
    case eCrsUp:
	return Point(0,-1);
    case eCrsDown:
	return Point(0,1);
    case eCrsLeft:
	return Point(-1,0);
    case eCrsRight:
	return Point(1,0);
    default:
	return gPoint0;
    }
}

void Token::Dump()
{
    extern int gDebug;
    char *c= "???";
    
    if (gDebug == 0)
	return;
    
    int code= Code;
    switch(Code) {
    case eEvtNone:
	c= "None";
	break;
    case eEvtLocMove:
	c= "LocMove";
	break;
    case eEvtLocStill:
	c= "LocStill";
	break;
    case eEvtEnter:
	c= "Enter";
	break;
    case eEvtExit:
	c= "Exit";
	break;
    case eEvtLocMoveBut:
	c= "LocMoveBut";
	break;
    case eEvtIdle:
	c= "Idle";
	break;
    case eEvtLeftButton:
	c= "LeftButton";
	break;
    case eEvtMiddleButton:
	c= "MiddleButton";
	break;
    case eEvtRightButton:
	c= "RightButton";
	break;
    default:
	if (Code >= eEvtPfkFirst && Code <= eEvtPfkLast) {
	    c= "PfkFirst";
	    code-= eEvtPfkFirst;
	} if (Code >= eEvtAscFirst && Code <= eEvtAscLast)
	    c= "AscFirst";
	if (Code >= eEvtMetaFirst && Code <= eEvtMetaLast)
	    c= "MetaFirst";
	break;
    }
    gCerr.form("c:%s(%d) f:%04x x:%d y:%d\n", c, code, Flags, Pos.x, Pos.y);
}
