#ifndef TypeMatcher_First
#ifdef __GNUG__
//pragma once
#pragma interface
#endif
#define TypeMatcher_First

#include "Object.h"
#include "Symbol.h"
#include "Bitmap.h"

class OrdCollection;
class Bitmap;
class Data;

extern SmartBitmap gImageIcon;

//---- file types --------------------------------------------------------------

extern const char *cMagic;  // magic cookie for ET++ generated files

//---- TypeMatcher -------------------------------------------------------------

class TypeMatcher: public Object {
public:
    MetaDef(TypeMatcher);
    TypeMatcher(const Symbol &t, char *ext, char *tag, bool ia, int prio= 1000);
    ~TypeMatcher();
    
    virtual Bitmap *GetBitmap();
    
    Symbol GetType();

    static void AddMatcher(TypeMatcher *m);
    static TypeMatcher *MatchByName(Data*);
    static TypeMatcher *MatchByContents(Data*);

protected:
    virtual bool MatchExtension(Data*, char *extension);
    virtual bool MatchPathName(Data*, char *pathname, int len);
    virtual bool MatchNameAndContents(Data*, char *pathname, char *buf, int len);
    virtual bool MatchContents(Data*, char *buf, int len);
    int Compare(Object *op);
    
protected:
    Symbol *type;
    char *extension, *tag;
    int priority;

public:
    bool ascii;

private:
    static OrdCollection *matchers;
    static bool sorted;
};

inline Symbol TypeMatcher::GetType()
    { return *type; }

#endif
