#if defined(__GNUG__) && __GNUG__ >= 2
#  pragma implementation
#endif

#include "UnixPtty.h"
#include "CLib.h"

//---- UnixPttyConnection ---------------------------------------------

UnixPttyConnection::UnixPttyConnection (char * name, char ** args)
{
  ptty_spawn_slave (&pty, name, args);
}

UnixPttyConnection::~UnixPttyConnection()
{
  ptty_kill_child (&pty);
  ptty_cleanup (&pty);
}
    
int
UnixPttyConnection::GetFileNo()
{
  return pty.master_fd;
}

int
UnixPttyConnection::GetPid()
{
  return pty.slave_pid;
}
    
int
UnixPttyConnection::Read (char * buf, int size)
{
  return CLib::Read (pty.master_fd, buf, size);
}

void
UnixPttyConnection::KillChild()
{
  ptty_kill_child (&pty);
  ptty_cleanup (&pty);
}

void
UnixPttyConnection::CleanupPtty()
{
  ptty_cleanup (&pty);
}

bool
UnixPttyConnection::RawOrCBreak()
{
  return TRUE;
}

void
UnixPttyConnection::SetSize (int lines, int columns)
{
  ptty_set_size (&pty, lines, columns);
}

void
UnixPttyConnection::GetPttyChars (PttyChars * pc)
{
  pc->erase = pty.cc_erase;
  pc->kill  = pty.cc_kill;
  pc->rprnt = pty.cc_rprnt;
  pc->susp  = pty.cc_susp;
  pc->intr  = pty.cc_intr;
  pc->quit  = pty.cc_quit;
  pc->eof   = pty.cc_eof;
}
