#ifndef _system_h_
#define _system_h_

#ifdef __GNUG__
#  pragma interface
#endif

#define MAXSIGNALS 11

#define NBBY    8               /* number of bits in a byte */

#ifndef FD_SETSIZE
#  define FD_SETSIZE 256
#endif

#ifndef howmany
#ifdef  sun386
#define howmany(x, y)   ((((u_int)(x))+(((u_int)(y))-1))/((u_int)(y)))
#else
#define howmany(x, y)   (((x)+((y)-1))/(y))
#endif
#endif

#if defined(OS_LINUX)
#define NFDBITS (sizeof (fd_mask) * NBBY)       /* bits per mask */

#define FD_SET(n, p)    ((p)->fds_bits[(n)/NFDBITS] |= (1 << ((n) % NFDBITS)))
#define FD_CLR(n, p)    ((p)->fds_bits[(n)/NFDBITS] &= ~(1 << ((n) % NFDBITS)))
#define FD_ISSET(n, p)  ((p)->fds_bits[(n)/NFDBITS] & (1 << ((n) % NFDBITS)))
#define FD_ZERO(p)      memset((char *)(p), 0, sizeof (*(p)))

#endif /* OS_LINUX */

typedef void (*sigHandlerType)(Signals);
typedef void* (*func)(...);

extern "C" {
    void    unix_initialize (void);
    char*   unix_getdirentry(void*);
    char*   unix_workingdirectory();
    char*   unix_initialworkingdirectory();
    char*   unix_homedirectory(char *name= 0);
    int     unix_waitchild();
    int     unix_myread(FILE*, int, void*, int);
    int     unix_select(u_int nfds, fd_set *readready, fd_set *writeready, u_int timeout);
    void    unix_signal(Signals, sigHandlerType);
    void    unix_resetsignal();
    char*   unix_signame(Signals);
    int     unix_filestat(char *path, u_long *id, u_long *size, u_long *flags, u_long *modtime);
    int     unix_fileaccess(char *path, int mode);

    int     unix_TcpConnect(char *hostname, char *servicename);
    int     unix_UnixConnect(char *name);
    int     unix_TcpService(char *servicename);
    int     unix_UnixService(char *servername);
    int     unix_accept (int sock);
    char*   cuserid(char *);
    void    statCache(bool sw);
}

extern "C" {
    void*   opendir(char *name);
    void    closedir(void*);
    int     accept(int, int, int);
    int     access(const char*, int);
    int     chdir(const char*);
#ifndef OS_ULTRIX
    int     rename(const char*, const char*);
#endif
    int     sleep(...);
    int     rmdir(char *);
#ifndef OS_SCO
    int     unlink(char *);
#endif
    int     getpid();

#ifndef __GNUG__
    char    *getenv(const char*);
#endif
}

extern int errno, sys_nerr;
extern char* sys_errlist[];

#endif
