#ifndef Window_First
#ifdef __GNUG__
//pragma once
#pragma interface
#endif
#define Window_First

#include "Clipper.h"
#include "WindowSystem.h"

class Manager;
class WindowPort;
class Menu;

extern Token
    gToken,
    gLastClickToken;
extern Window *gWindow;

//---- Window ------------------------------------------------------------------

class Window: public Clipper {
protected:
    bool active;
    GrCursor cursor;
    WindowPort *portDesc;     // Port descriptor
    Manager *manager;
    VObject *inner;
    WindowType wtype;
    WindowFlags wflags;

    void Init(Manager *eh, VObject *in, WindowType wt, GrCursor curs,
					    WindowFlags f, char *t, Point e);
    WindowPort *MakePort();
public:
    MetaDef(Window);
    
    Window(Manager*, Point e, WindowFlags f, VObject*, char *title= "");
    Window(Manager*, VObject *contents, WindowType wt, WindowFlags f,
						Point e= gPoint_1, char *t= "");
    ~Window();

    WindowFlags GetWindowFlags();
    WindowType  GetWindowType();

    bool IsActive();
    
    EvtHandler *GetNextHandler();
    void SetNextManager(Manager*);

    void InputNotify(Token *t);
    void FocusNotify(bool f);
    void OpenNotify(Point e);
    void CloseNotify();
    void ResizeNotify(Point e);

    void SetOrigin(Point at);
    void SetExtent(Point e);
    void ExtentChanged(VObject *what);
    void Focus();
    void InvalidateRect(Rectangle);
    void PushBackEvent(Token);
    void Open(bool mode= TRUE);
    void OpenAt(Point p, VObject *vf= 0, bool resize= FALSE, bool block= FALSE);
    GrCursor GetCursor(Point);

    Port *GetPortDesc();
    void SetPortDesc(Port *);

    Rectangle ScreenRect();
    Rectangle GetRect();
    void ReadEvent(Token &t, int timeout= -1, bool overread= TRUE);
    void Bell(long d= 100);
    void SetMousePos(Point);
    void Grab(bool on, bool fullscreen);
    void Top();
    void Bottom();
    void SetTitle(char*);

    void Iconize();
    void SetIconTitle(char*);

    void HideAndRemember();
    void Unhide();
};

inline WindowFlags Window::GetWindowFlags()
{
    return wflags;
}

inline WindowType Window::GetWindowType()
{
    return wtype;
}

inline bool Window::IsActive()
{
    return active;
}

inline Port *Window::GetPortDesc()
{
    return (Port*)portDesc;
}

inline void Window::SetPortDesc(Port *newport)
{
    portDesc= (WindowPort*)newport;
}

#endif
