//-*-Mode: C++;-*-
#ifndef _XColorMap_h_
#define _XColorMap_h_

#if defined(__GNUG__) && __GNUG__ >= 2
#  pragma interface
#endif

#include "X11.h"
#include "WindowColorMap.h"

//---- XColorIndexMapper ----------------------------------------------

class XColorIndexMapper : public WindowColorMap {
public:
    XColormap cmap;
    struct color_cell_t {
	RGB client;
	RGB server;
	bool is_valid;
	int ref_cnt;
    } *color_table;		// array of "ncolors" entries
				// index is the pixel value
    int ncolors;
    bool local_colormap;	// all X colormap entries are in our table ?

public:
    XColorIndexMapper(XColormap cm, int colormap_size);
    ~XColorIndexMapper();
    u_long DevRGB2Index(RGB *rgb, RGB *result);
    void DevIndex2RGB(u_long ix, RGB *result);
    void DevFreeRGB(RGB *rgb);
};

//---- XColorDirectMapper ---------------------------------------------

class XColorDirectMapper : public WindowColorMap {
    u_long red_mask, green_mask, blue_mask;
    int red_shift, green_shift, blue_shift;
    int red_mult, green_mult, blue_mult;
public:
    XColorDirectMapper(Visual *);
    u_long DevRGB2Index(RGB *rgb, RGB *result);
    void DevIndex2RGB(u_long ix, RGB *result);
};

#endif
