#if __GNUG__ >= 2
#  pragma implementation
#endif

#include "BackupOStream.h"
#include <unistd.h>
#include "CLib.h"
#include "System.h"
#include "Env.h"
#include "ETString.h"

bool IsRegularFile(char *path) 
{
	if(access(path,R_OK)) {
   		//printf("File %s not found\n",path);
   		return FALSE;
   	}
   	return TRUE;
}

//---- BackupOStream ---------------------------------------------------------

BackupOStream::BackupOStream(char* path)
{
	MakeBackup(path);
	itsStream=new OStream(path);
}

BackupOStream::BackupOStream(char* path, StreamBuf* s, bool dodelete)
{
	MakeBackup(path);
	itsStream=new OStream(s,dodelete);
}

BackupOStream::~BackupOStream()
{
	if(itsStream) {
	    CleanBackup();
	    SafeDelete(itsStream);
	}
}

void BackupOStream::DeleteStream()
{
	CleanBackup();
	SafeDelete(itsStream);}
 
 
bool BackupOStream::MakeBackup(char *s)
{
	if (IsRegularFile(s)) // make backup
		gSystem->RunProgSynch(::form("cp %s %s%s", s, s, "%"));
	backupFile=strsave(::form("%s%s", s, "%"));
	return TRUE;
}

bool BackupOStream::CleanBackup()
{
	bool makeBackup=Env::GetValue("Document.MakeBackup",TRUE);
	if (itsStream->good() && !makeBackup)
	    CLib::Unlink(backupFile);
	delete backupFile;
	return TRUE;
}
