#ifndef ByteArray_First
#ifdef __GNUG__
//pragma once
#pragma interface
#endif
#define ByteArray_First

#include "Object.h"

//---- class ByteArray ---------------------------------------------------------
extern char *cAtPutName;
extern char *cOutOfBoundsError;

class ByteArray: public Object {
    byte *cont;
    int  cap;

    void AllocByteArray(byte *aStr, int l= -1);
    
public:
    MetaDef(ByteArray);

    //---- creation, destruction  
    ByteArray(int size);              
    ByteArray(byte *aStr, int l= -1);               
    ByteArray(char *aStr, int l= -1);               
    ~ByteArray();

    //---- accessing
    byte *Str ()
	{ return cont; }
    char *CharStr ()
	{ return (char*)cont; }
    void SetString (byte *s); 
    void operator= (byte *s);
    char At(int i)
	{ return cont[i]; }
    void AtPut(int i, byte c)
	{ if ( i < 0 || i >= cap)
	    Error(cAtPutName, cOutOfBoundsError);
	  else
	    cont[i]= c; 
	}

    //---- standard overriden methods   
    unsigned long Hash ();
    bool IsEqual (Object*);
    int Compare (Object*);
    OStream& PrintOn(OStream&);
    IStream& ReadFrom(IStream&);
    void InspectorId(char *buf, int sz);
};

#endif
