#ifndef CLib_First
#define CLib_First

#ifdef __GNUG__
#  pragma interface
#endif

#include "Types.h"
#include <fcntl.h>

class CLib {
public:
    static char **Environ();
    static int EnvironLength();

    static char* BSearch(const char *key, char *base, unsigned nel, int size, int (*)(const void*, const void*));   
    static void QSort(void*, int, int, int (*)(const void*, const void*));

    static char* Getenv(const char*);
    static int Putenv(const char*);

    //static int System(const char*);
    //replaced by: System::RunProgSynch()/RunProgAsynch()
    static void Abort();
    static void Exit(int);
    static void FastExit(int);

    static int Open(const char*, int);
    static int Creat(const char*, int);
    static int Read(int fd, char *buf, int nbyte);
    static int Write(int fd, const char *buf, unsigned int nbyte);
    static int Close(int);
    static long Lseek(int , long, int);
    static int Unlink(const char*);
#ifdef OS_WINDOWS_WINSOCK
    static int Recv(int sock, char *buf, int sz, int flags);
    static int Send(int sock, char *buf, int sz, int flags);
    static int Closesocket(int sock);
#endif
#if 1
	// If nobody uses it we will remove it from next release
#else
    static int Link(const char *frm, const char *to);
    static unsigned int Alarm(unsigned int secs);
#endif
    static int Rename(const char *from, const char *to);
    static int Symlink(const char *from, const char *to);

    static int Free(char *);
    static char *ReAlloc(char *, int sz);
    static char *CAlloc(int n, int sz);
    static void SetMallocFailedHook ( void (*hook) (void) );
};


// --- Glob --- file name pattern matching ----------------------------------

class Glob {
public:
    static int HasPattern (char *pattern);
    static int Match (char *pattern, char *text, int dot_special);
private:
    static int MatchAfterStar (char *pattern, char *text);
};

#endif
