#ifndef ClassManager_First
#ifdef __GNUG__
//pragma once
#pragma interface
#endif
#define ClassManager_First

#include "Object.h"
#include "OrdColl.h"

//---- ClassManager ------------------------------------------------------------

class ClassManager: public Object {
    OrdCollection *classTable;
    bool sorted;

    OrdCollection *sortClassTable();

public:
    MetaDef(ClassManager);
    ClassManager();
    ~ClassManager();
    
    //---- class table management
    OrdCollection *GetClassTable()
	{ return sorted ? classTable : sortClassTable(); }
    void Add(Class*);
    void Remove(Class*);
    class Iterator *Iterator()
	{ return GetClassTable()->MakeIterator(); }
    Class *Find(char *name, double version= 0.0);
    Class *FindOrLoad(char *name, double version= 0.0);
    Object *Load(char *module, char *cla);
    
    //---- misc
    void SetupSubclasses();
    void InstanceStatistics(bool cumSorted= FALSE);
};

extern ClassManager *gClassManager;


#endif

