#ifndef Debug_h_First
#define Debug_h_First

#ifdef OS_WINDOWS
#  include <RDebug.h>
#else
    #include "Error.h"
    
    #define TPR printf
    
    #undef ASSERT
    #define ASSERT(c)						\
	if (!(c)){ ::Error("", "ASSERTION failed: %s   [%s, %d]", #c, __FILE__, __LINE__); }
    
    #undef TDYN
    #undef TDYNNL
    #undef TSTA
    #undef TSTANL
    #define TDYN(o)     						\
	TPR("%s <%s>(%p)", #o, o->ClassName(), o );
	//DebugOutputManager::PrintDyn(#o, typeid(o), o );
    #define TDYNNL(o)     						\
	TPR("%s <%s>(%p)", #o, o->ClassName(), o ); TPR("\n");
	//DebugOutputManager::PrintDyn(#o, typeid(o), o ); TPR("\n");
    #define TSTA(o)     						\
	TPR("%s <%s>(%p)", #o, o.ClassName(), &o );
	//DebugOutputManager::PrintSta(#o, typeid(o), &o );
    #define TSTANL(o)     						\
	TPR("%s <%s>(%p)", #o, o.ClassName(), &o ); TPR("\n");
	//DebugOutputManager::PrintSta(#o, typeid(o), &o ); TPR("\n");
    // ----------------------------------
    // usage:
    // ------
    // TPR("TPR can be used just like a normal printf (%d) (%f)\n<%s>\n", i, 123.456, s);
    //
    // ASSERT(5==5) //"throws" an error if <cond> is NOT true
    //
    // TDYN(dynVar)   //prints the name, type, and contents of dynVar
    // TDYNNL()       //dito TDYN() but with NL 
    // TSTA(statVar)  //prints the name, type, and contents of statVar
    // TSTANL()       //dito TSTA() but with NL 
    // --------------------------------------------------------------------------

    // MEMOUT...: yet to come

#endif


#endif //Debug_h_First
