#ifdef __GNUG__
#pragma implementation
#endif

#include "ETMath.h"

// math.h should be edited on aix: 
// extern int class(); should be deleted
#include <math.h>

#ifdef sun
extern "C" void sincos(double, double*, double*);
#endif /* sun */

const double Math::Pi = 3.14159265358979323846,
	     Math::E  = 2.7182818284590452354;
       
int Math::Sqrt(int x)
{
    return (int) (sqrt(x) + 0.5);
}

double Math::Sqrt(double x)
{
    return sqrt(x);
}

int Math::Hypot(int x, int y)     // return sqrt(px*px + py*py);
{
    return (int) (hypot(x, y) + 0.5);
}

double Math::Hypot(double x, double y)
{
    return hypot(x, y);
}

double Math::Sin(double x)
{
    return sin(x);
}

double Math::Cos(double x)
{
    return cos(x);
}

double Math::ASin(double x)
{
    return asin(x);
}

double Math::ACos(double x)
{
    return acos(x);
}

double Math::ATan(double x)
{
    return atan(x);
}

double Math::ATan2(double x, double y)
{
    return atan2(x, y);
}

double Math::Ceil(double x)
{
    return ceil(x);
}

double Math::Floor(double x)
{
    return floor(x);
}

double Math::Exp(double x)
{
    return exp(x);
}

double Math::Power(double x, double y)
{
    return pow(x, y);
}

double Math::Atan2(int y, int x)
{
    double dd= (0.75 - (atan2(-y, x) / Math::Pi + 1.0)/2.0 ) * 360.0;
    while (dd < 0.0)
	dd+= 360.0;
    return dd;
}

double Atan2(double fy, double fx)
{
    return Math::Atan2((int)(fy+0.5), (int)(fx+0.5));
}

void
Math::Sincos (double a, double * sinp, double * cosp)
{
  double si, co;

  if ( a == 0.0 || a == 360.0 )
    {
      si = 1.0;
      co = 0.0;
    }
  else if ( a == 90.0 )
    {
      si = 0.0;
      co = 1.0;
    }
  else if ( a == 180.0 )
    {
      si = -1.0;
      co = 0.0;
    }
  else if ( a == 270.0 )
    {
      si = 0.0;
      co = -1.0;
    }
  else
    {
      a = 2 * Math::Pi * (90.0 - a) / 360.0;

#ifdef OS_SUNOS_4_1
      sincos (a, &si, &co);
#else 
      si = sin (a);
      co = cos (a);
#endif
    }

  *sinp = - si;
  *cosp = co;
}

int Math::NextPrime(int x)
{
    int n, sqr;
    
    if (x <= 3) 
	return 3;
	
    if (x % 2 == 0) 
	x++;
/* Change by Bryan Boreham, Kewill, Thu Aug 10 15:16:35 1989.
   Added the cast to double to get g++ to use the inline version.    */
#ifdef __GNUG__
    sqr= (int) sqrt((double)x) + 1;
#else
    sqr= (int) sqrt(x) + 1;
#endif
    for (;;) {
	for (n = 3; (n <= sqr) && (x % n != 0); n+= 2) 
	    ;
	if (n > sqr) 
	    return x;
	x+= 2;
    }
}
