#ifndef Filebuf_First
#ifdef __GNUG__
//pragma once
#pragma interface
#endif
#define Filebuf_First

#include "StreamBuf.h"

enum open_mode { input= 0, output= 1, append= 2 };

enum ELineSeparatorStyle {
    cLineSeparatorStyleNotSet	= -2,
    cLineSeparatorStyleUnknown	= -1,
    cLineSeparatorStyleAsIs	= 0,
    cLineSeparatorStyleUnix	= 1,
    cLineSeparatorStyleDos	= 2,
    cLineSeparatorStyleMac	= 3
};

//---- Filebuf -----------------------------------------------------------------

class Filebuf : public StreamBuf {     // a Stream buffer for files
protected:
    int fd;         // file descriptor
    bool opened;    // non-zero if file has been opened
    bool mapped;
    char *itsFile;
public:
    Filebuf();
    Filebuf(int nfd);
    Filebuf(int nfd, char* p, int l);
    Filebuf(char *path, open_mode m);

    ~Filebuf();
    
    bool isopen()
	{ return opened; }

    // Open a file. return 0 if failure; return "this" if success
    Filebuf* open(char *name, open_mode om);
    
    bool close();
    int Overflow(u_char *bp, int size);
    int Underflow(u_char *p, int l);
    long Seek(long pos, int whence);
    
    char *ItsFile() {return itsFile;}
};


//---- FilebufAscii ---------------------------------------------------------------
class FilebufAscii: public Filebuf {
public:
    FilebufAscii(char *path, open_mode m) : Filebuf(path, m)
	{}
};

//---- FilebufAsciiEncoder --------------------------------------------------------------
class FilebufAsciiEncoder: public FilebufAscii {
public:
    FilebufAsciiEncoder(char *path, ELineSeparatorStyle lss);
    int Overflow(u_char *bp, int size);
private:
    ELineSeparatorStyle fLineSeparatorStyle;
};

//---- FilebufAsciiDecoder --------------------------------------------------------------
class FilebufAsciiDecoder: public FilebufAscii {
public:
    FilebufAsciiDecoder(char *path);
    int Underflow(u_char *bp, int size);
};



#endif
