#ifdef __GNUG__
#pragma implementation
#endif

#include "Progress.h"
#include "Class.h"

#define SHOW_PROGRESS_DELAY 2

extern "C" {
  long time (long *);
};

static Progress dfltProgress;
Progress *gProgress= &dfltProgress;

//---- Progress ----------------------------------------------------------------

static bool inProgress;

NewMetaImpl(Progress, Object,(TB(wasAborted),TB(inProgress),
		    T(curr), T(max),TB(timeout),T(start_time)));

Progress::Progress()
{
    timeout = FALSE;
}

void Progress::Start(char *message, int mx, bool stop, bool forward)
{
    if (inProgress)
	Stop();
    wasAborted=FALSE;
    inProgress= TRUE;
    fwd= forward;
    curr= fwd ? 0 : mx;

    timeout = FALSE;
    start_time = time (0);

    SetMax(mx);
    SetMessage(message);
    SetStop(stop);
    SetUp();
}

bool Progress::Tick (int val)
{
    if ( ! inProgress )
	return FALSE;

    curr = val;
    if ( ! timeout ) {
    	long now = time (0);
    	if ( (now - start_time) > SHOW_PROGRESS_DELAY )
	    timeout = TRUE;
    }
    return timeout ? SetVal() : FALSE;
}

void Progress::SetStop(bool)
{
}

void Progress::SetUp()
{
}

void Progress::SetMessage(char*)
{
}

bool Progress::SetVal()
{
    return FALSE;
}

bool Progress::Stop()
{
    Abort(TRUE);
    timeout= FALSE;
    inProgress= FALSE;
    return wasAborted;
}

void Progress::EnableAbort(bool stop)
{
    SetStop(stop);
}

void Progress::Abort()
{
    Abort(FALSE);
    wasAborted=TRUE;
    timeout= FALSE;
    inProgress= FALSE;
}

void Progress::Abort(bool)
{
}

bool Progress::WasAborted()
{
    return wasAborted;
}
