#ifndef Progress_First
#ifdef __GNUG__
//pragma once
#pragma interface
#endif
#define Progress_First

#include "Object.h"

//---- Progress ----------------------------------------------------------------

class Progress : public Object {
public:
    MetaDef(Progress);
    Progress();

    void Start(char *message, int mx, bool enable_abort= TRUE, bool forward= TRUE);
	// start progress indicator with message and max tick count mx
    virtual void SetMessage(char *message);
	// change indicator message on-the-fly
    void SetMax(int mx);
	// set maximum tick
    bool Tick(int curr);
	// set absolut tick
    bool Inc(int inc);
	// increment tick; 
    bool Stop();
	// stop progress (normal end); returns same as WasAborted()

    void Abort();
	// abort progress (abnormal end)
    void EnableAbort(bool stop);
	// allow/disallow aborting; (e.g. show a "stop" button)
    bool WasAborted();
protected:
    virtual void SetUp();
    virtual bool SetVal();
    virtual void Abort(bool skiptoend);
    virtual void SetStop(bool stop);

    int curr, max;
    bool fwd;
    bool timeout;
    long start_time;
    bool wasAborted;
};

extern Progress *gProgress;

inline void Progress::SetMax(int mx)
{
    max= mx;
}

inline bool Progress::Inc (int inc)
{
    return Tick (fwd ? (curr + inc) : (curr - inc));
}

#endif
