#ifndef Storage_First
#ifdef __GNUG__
//pragma once
#pragma interface
#endif
#define Storage_First

#include "Types.h"

typedef void (*FreeHookFun)(void *, void *addr, size_t);

//---- Pools of fixed size storage allocators -----------------------

class Storage {
    char dummy;
public:
    static void *Alloc(size_t sz);
    static void Free(void *vp);

    static void *ChunkAlloc(size_t sz);
    static void ChunkFree(void *vp);

    static void *ObjectChunkAlloc(size_t sz);
    static void ObjectChunkFree(void *vp);

    static void *ObjectAlloc(size_t sz);
    static void ObjectFree(void *vp);

    static void *ReAlloc(void *vp, size_t sz);

    static void Statistics();
    static void SetFreeHook(FreeHookFun, void *data);
    static void FreeAll();
    static void EnableStatistics(int size= -1, int ix= -1);
};

//---- misc ---------------------------------------------------------

#ifdef __GNUG__

# ifdef linux
#  include <alloca.h>
# else
#ifndef OS_ULTRIX
#  define alloca(size) __builtin_alloca(size)
#endif
   extern "C" void * alloca (size_t);
# endif

#  define Alloca(x) alloca(x)
#  define Freea(x)

#else	/* not __GNUG__ */

#  define Alloca(x) ((void*) (new char[x]))
#  define Freea(x) delete (x)

#endif	/* not __GNUG__ */

#endif
