#ifdef __GNUG__
#  pragma implementation
#endif

#include "Symbol.h"

#include "Class.h"
#include "ETString.h"

//---- SymbolTable -------------------------------------------------------------

static SymbolTable gSymTab;
    
char **SymbolTable::table;
int SymbolTable::size;
int SymbolTable::allocsize;

NewMetaImpl(SymbolTable,Object, (TVP(table,size)));

SymbolTable::SymbolTable()
{
}

SymbolTable::~SymbolTable()
{
    if (table) {
	for (int i= 1; table[i]; i++)
	    SafeDelete(table[i]);
	SafeDelete(table);
    }
}

char *
SymbolTable::Lookup(const char *name)
{
    int last= size-1, base= 0, result, position;
    if (table && name) {
	while (last >= base) {
	    position= (base+last) / 2;
	    if ((result= strcmp(table[position], name)) == 0)
		return (char *) table[position];
	    if (result > 0)
		last= position-1;
	    else
		base= position+1;
	}
    }
    return 0;
}

char *
SymbolTable::MakeId(const char *name)
{
    if (name) {
	if (table == 0) {
	    allocsize=32;
	    table= new char* [allocsize];
	}
	int last= size-1, base= 0, result, position= 0;
	if (table && name) {
	    while (last >= base) {
		position= (base+last) / 2;
		if ( (result= strcmp(table[position], name)) == 0)
		    return (char *) table[position];
		if (result > 0)
		    last= position-1;
		else
		    base= position+1;
	    }
	}
	if (size >= allocsize) {
	    // larger table needed...
	    allocsize*= 2;
	    char **newtable= new char* [allocsize];
	    for (int i= 0; i < size; i++)
		newtable[i]= table[i];
	    SafeDelete(table);
	    table= newtable;
	}
	if (table[position] && strcmp(table[position], name) < 0)
	    position= position+1;

	for (int i= size; i > position; i--)
	    table[i]= table[i-1];
	size++;

	table[position]= strsave(name);
	return (char *) table[position];
    }
    return 0;
}

OStream&
Symbol::PrintOn(OStream &s) const
{
    return s.PrintString((char*) id);
}

IStream&
Symbol::ReadFrom(IStream &s)
{
    char *tmp= 0;
    
    s.ReadString(&tmp);
    id= SymbolTable::MakeId(tmp);
    delete tmp;
    return s;
}

SimpleMetaImpl(Symbol)
{
    len= len;
    if (! isptr)
	sprintf(buf, "%s", ((Symbol*)addr)->AsString());
}

