#ifndef _Symbol_h_
#define _Symbol_h_

#ifdef __GNUG__
#  pragma interface
#endif

#include "Object.h"

class SymbolTable: public Object {
    static char **table;
    static int size;
    static int allocsize;
public:
    MetaDef(SymbolTable);
    SymbolTable();
    ~SymbolTable();
    static char * Lookup(const char *name);
    static char * MakeId(const char *name);
};

class Symbol {
    char * id;
public:

    Symbol()
	{ id= 0; }
    Symbol(char *name)
	{ id= SymbolTable::MakeId(name); }
    Symbol(const Symbol &at)
	{ id= at.id; }
    
    void operator=(const Symbol &at)
	{ id= at.id; }

    char * Id() const
	{ return id; }

    char *AsString() const
	{ return (char*) id; }
    
    friend bool operator== (const Symbol &a1, const Symbol &a2)
	{ return (bool) (a1.id == a2.id); }

    friend bool operator!= (const Symbol &a1, const Symbol &a2)
	{ return (bool) (a1.id != a2.id); }

    OStream& PrintOn(OStream &s) const;
    IStream& ReadFrom(IStream&);
    
    friend OStream& operator<< (OStream &s, const Symbol &a)
	{ return a.PrintOn(s); }

    friend IStream& operator>> (IStream &s, Symbol &a)
	{ return a.ReadFrom(s); }
};

SimpleMetaDef(Symbol);

#endif
