#ifndef BrowserDoc_First
#ifdef __GNUG__
//#pragma once
#pragma interface
#endif
#define BrowserDoc_First

#include "Document.h"

//---- BrowserDocument ---------------------------------------------------------------

class Text;
class VObjectText;
class BrowserView;
class FileBrowserTextView;
class TextItem;
class Window;
class ShellTextView;
class Scroller;
class Clipper;
class ShellManager;
class SeqCollection;
class PullDownButton;
class Filler;

class BrowserDocument : public Document {
friend ShellManager;
    BrowserView *browserView, *bv; // view on top of window
    VObject *browser;
    FileBrowserTextView *textView; // text view below
    Menu *functionMenu;
    ShellManager *shellManager;
    Scroller *scroller;
    Clipper *tvClipper;    
    VObjectText *text;                    // text installed in textView
    int nFileLists;
    bool isCCode;
    bool doRevert;                 // revert in progress?
    PullDownButton *pdm;
    Filler *filler;
private: 

    void ShowShell(char *path);
    void ShowError(char *errMsg);
    void ShellExecute(char *cmd);
    Document *IsAlreadyOpen(Data *data);
    void ApplyPreferences();
    void ExecuteMake();
    VObjectText *MakeText();
    void InstallText(Text*, bool);
    void SetSharedWindowTitle();
    void AddKeySelectItem(VObject *vop);
      
    void ShowReverted(Text *t, Data *data); 
     
public:
    MetaDef(BrowserDocument);
    
    BrowserDocument();
    ~BrowserDocument();
    
    CommandProcessor *MakeCmdProcessor();
    VObject *DoMakeContent();
    
    FileBrowserTextView *GetTextView()
	{ return textView; }
    bool ShowsFileLists();
    
    //---- input/output (overrides from Document)
    bool DoReadData(Data *data);
    bool DoWrite(OStream&, Data *);
    bool DoFileIsAlreadyOpen(Document *shown, char *name);
    void Revert();
    bool SavedChanges();
    
    //---- overrides from Manager
	void SetWindowTitle(char *t);
	
    //---- event handling
    void Control(int id, int, void *);
    void InputKbd(Token &t);

    //---- menus
    MenuBar *DoMakeMenuBar();
    Command *DoMenuCommand(int cmd);
    void DoSetupMenu(Menu *menu);    
};

#endif
