#ifdef __GNUG__
#pragma implementation
#endif
#include "BrowserItems.h"

#include "Class.h"
#include "Buttons.h"
#include "CollView.h"
#include "Scroller.h"
#include "System.h"
#include "Menu.h"
#include "ETString.h"
#include "OrdColl.h"
#include "FileDialog.h"

#include "BrowserCmdNo.h"

const int cListMinWidth= 160,
	  cListMaxLines= 7;
const Point cIconSize(16);

//---- FileList ----------------------------------------------------------------

NewMetaImpl(FileList,Expander, (TP(files), TP(but), TP(scroller)));

FileList::FileList(int id) : Expander(cIdNone, eVert, 3, (SeqCollection*)0)
{
    Add(but= new ActionButton(cFbShowShell, ""));
    files= new CollectionView(this, new OrdCollection(), eCVDontStuckToBorder);
    files->SetId(id);
    files->SetMinExtent(Point(cListMinWidth, 0));
    scroller= new Scroller(files, Point(cListMinWidth, cListMaxLines*cIconSize.y));
    Add(scroller);
}

FileList::~FileList()
{
    SafeDelete(files);
}

void FileList::Control(int id, int part, void *val)
{
    if (id == cFbShowShell) 
	Control(files->GetId(), cFbShowShell, 0);
    else
	Expander::Control(id, part, val);
}

bool FileList::GrabKeyToken(Token &t)
{
    if (scroller->ContainsPoint(t.Pos)) {
	scroller->Input(t.Pos, t, GetWindow());
	return TRUE;
    }
    return FALSE;
}

void FileList::SetContents(char *t, SeqCollection *col)
{
    but->Enable(col != 0);
    but->SetLabel(t, TRUE);
    if(col)
		files->SetCollection(col, FALSE);   // FALSE->do not free old collection
} 
    
FileItem *FileList::GetSelectedItem()
{
    Rectangle r = files->GetSelection();
    int at= r.origin.y;
//  ClearSelection sends a Control message
//    files->ClearSelection();
    return Guard(files->GetCollection()->At(at), FileItem);
}

//---- FunctionMark -------------------------------------------------------

NewMetaImpl(FunctionMark,Mark, (TP(name), TB(method)));
    
FunctionMark::FunctionMark(char *n, bool m, int p, int l) : Mark(p, l)
{
    name= strsave(n);
    method= m;
}

FunctionMark::~FunctionMark()
{
    SafeDelete(name);
}

