#ifndef BrowserView_First
#ifdef __GNUG__
//#pragma once
#pragma interface
#endif
#define BrowserView_First

#include "Box.h"
#include "CodeTextView.h"

class PrettyPrinter;
class ChangeDirDiag;
class FileList;

//---- BrowserView -------------------------------------------------------------

class BrowserView: public VBox {
protected:
    SeqCollection *path, *directories;    
    CompositeVObject *fileLists;  // shown file lists
    int nShown;                         // number of shown file lists
    int left;                           // index of left most file list in "path"
    VObject *shiftLeft, *shiftRight;    // buttons
    
    ChangeDirDiag *changeDir;    

    void LoadFile(int at, FileList *fl);
    void Shell(int at, char *path, char *cmd= 0);
    
public:
    MetaDef(BrowserView);
    BrowserView(EvtHandler *dp, int numFilelists);
    ~BrowserView();
    
    //---- respond to user input
    void Control(int id, int detail, void *data);
    bool GrabKeyToken(Token &t);
    void DoSetup();
   
    //---- directory handling
    SeqCollection *ReadDirectory();
    void ShowDirectory(int at, char *name);
    void ShowParentDirectory();
    void ShiftFileLists(int to);
    void UpdateButtons();
    
    //---- accessing path and directories by index
    FileList *FileListAt(int i)
	{ return (FileList*)fileLists->At(i); }
    char *PathNameAt(int i);
    char *DirectoryNameAt(int i);
    SeqCollection *PathAt(int i)
	{ return (SeqCollection*)path->At(i); }

    void RemoveAndFreeLast(SeqCollection *col);
};

//---- FileBrowserTextView -----------------------------------------------------

class FileBrowserTextView: public CodeTextView {
public:
    MetaDef(FileBrowserTextView);
    FileBrowserTextView(EvtHandler *eh, Rectangle r, VObjectText *t);    

    PrettyPrinter *MakePrettyPrinter(Text *t, CharStyle *cs, CharStyle *fs,
						CharStyle *cds, CharStyle *ps);
    void SetupFunctionMenu(Menu *functionMenu);
    void CreateFunctionMenu(Menu *functionMenu);
    void GotoFunction(int i);
    void ResetFunctionMenu(); 
};

//---- FileBrowserPPrinter -----------------------------------------------------

class FileBrowserPPrinter: public PrettyPrinter {
    FileBrowserTextView *tvp;
public:
    FileBrowserPPrinter(FileBrowserTextView *tvp, Text *t, CharStyle *cs,
				CharStyle *fs, CharStyle *cds, CharStyle *ps);
    void ClassDecl(int, int start, int end, char *);
    void Function(int line, int start, int end, char *name, char *classname);
};

#endif
