#ifdef __GNUG__
#pragma implementation
#endif
#include "Preferences.h"
 
#include "Class.h"
#include "Form.h"
#include "BorderItems.h"
#include "Fields.h"
#include "ManyOfCluster.h"
#include "Buttons.h"
#include "Expander.h"
#include "PopupItem.h"
#include "Menu.h"
#include "Env.h"

//---- Id's --------------------------------------------------------------------

const int cIdPrefOpt    = cIdFirstUser + 3,
	    cIdPrfBak   = cIdPrefOpt,
	    cIdPrfFast  = cIdPrefOpt   + 1,
	  cIdTxtOpt     = cIdFirstUser + 13,
	    cIdPrfStyled= cIdTxtOpt,
	    cIdPrfAuto  = cIdTxtOpt    + 1,
	    cIdPrfWrap  = cIdTxtOpt    + 2,
	  cIdFontSize   = cIdFirstUser + 100,
	  cIdPanesNum   = cIdFirstUser + 200;

//---- PrefDialog --------------------------------------------------------------

NewMetaImpl0(PrefDialog,Dialog);

PrefDialog::PrefDialog() : Dialog("Preferences")
{
}

VObject *PrefDialog::DoMakeContent()
{
    Menu *m= new Menu("Font Size", FALSE);
    m->AppendItems(
	    "9",    cIdFontSize+9,
	    "10",   cIdFontSize+10,
	    "12",   cIdFontSize+12,
	    "14",   cIdFontSize+14,
	    "18",   cIdFontSize+18,
	    0); 
    Menu *m2= new Menu("Panes", FALSE);
    m2->AppendItems(
	    "1",    cIdPanesNum+1,
	    "2",    cIdPanesNum+2,
	    "3",    cIdPanesNum+3,
	    "4",    cIdPanesNum+4,
	    "5",    cIdPanesNum+5,
	    "6",    cIdPanesNum+6,
	    0); 
			
    VObject *textopt=
	    new Form(
		"Tabs (in Characters):",
		    ni= new IntField(cIdNone, 0, 20),
		"Make Command:",
		    make= new TextField(cIdNone, 10), 
		"Font Size:",
		    fontsize= new PopupButton(cIdNone, 9, m),
		"Number of Filelists:",
		    npanes= new PopupButton(cIdNone, 9, m2),
		0
	    );
	    
    return
	new Matte(
	    new VExpander(20,
		textopt,
		new HBox(10, (VObjAlign)(eVObjHGapExpand),
		    new BorderItem("Options",
			gopt= new ManyOfCluster(cIdPrefOpt,
			    "Make Backup",
			    "Fast Icons",
			    0
			)
		    ),
		    new BorderItem("Text Options",
			txtopt= new ManyOfCluster(cIdTxtOpt,
			    "Styled Text",
			    "Auto Indent",
			    "Word Wrap",
			    0
			)
		    ),
		    0 
		),
		new HBox(20, (VObjAlign)(eVObjVBase|eVObjHEqual|eVObjHExpand),
		    new ActionButton(cIdOk,      "Store", TRUE),
		    new ActionButton(cIdDefault, "Default"),
		    new ActionButton (cIdCancel, "Cancel"),
		    0
		),
		0
	    )
	);
}

void PrefDialog::DoSetDefaults()
{
    txtopt->SetItem(cIdPrfStyled, Env::GetValue("CodeText.UseStyles", TRUE));
    txtopt->SetItem(cIdPrfAuto, Env::GetValue("CodeText.AutoIndent", TRUE));
    txtopt->SetItem(cIdPrfWrap, Env::GetValue("CodeText.WordWrap", FALSE));
    gopt->SetItem(cIdPrfBak, Env::GetValue("Document.MakeBackup", TRUE));
    ni->SetValue(Env::GetValue("CodeText.TabPos", 8));
    fontsize->SetValue(cIdFontSize+Env::GetValue("filebrowser.FontSize", 12));
    gopt->SetItem(cIdPrfFast, Env::GetValue("filebrowser.FastIcons", TRUE));
    npanes->SetValue(cIdPanesNum+Env::GetValue("filebrowser.BrowserPanes", 3));
    make->SetString(Env::GetValue("filebrowser.MAKE", "make"));
}

void PrefDialog::DoStore()
{
    Env::SetBoolValue("*.CodeText.UseStyles", txtopt->IsItemOn(cIdPrfStyled));
    Env::SetBoolValue("*.CodeText.AutoIndent", txtopt->IsItemOn(cIdPrfAuto));
    Env::SetBoolValue("*.CodeText.WordWrap", txtopt->IsItemOn(cIdPrfWrap));
    Env::SetBoolValue("*.Document.MakeBackup", gopt->IsItemOn(cIdPrfBak));
    Env::SetValue("*.CodeText.TabPos", ni->GetValue());
    Env::SetBoolValue("filebrowser.FastIcons", txtopt->IsItemOn(cIdPrfFast));
    Env::SetValue("filebrowser.FontSize", fontsize->GetValue()-cIdFontSize);
    Env::SetValue("filebrowser.BrowserPanes", npanes->GetValue()-cIdPanesNum);
    Env::SetValue("filebrowser.MAKE", make->AsString());
    Env::Save();
}
 
//---- entry point -------------------------------------------------------------

int PrefDialog::ShowDialog(VObject *vop)
{
    return PrefDialog().ShowOnWindow(vop->GetWindow());
}

