#ifndef SharedDocObjects_First
#ifdef __GNUG__
//#pragma once
#pragma interface
#endif
#define SharedDocObjects_First

#include "Object.h"

//---- SharedDocObjects ------------------------------------------------------------

class Document; 
class Iterator;
class IdDictionary;

// SharedDocObject manages an IdDictionary. Key= Object Value= Collection of
// Documents displaying the SharedDocObjects

class SharedDocObjects {
    static IdDictionary *map;

public:
    static void AddRef(Object*, Document*);
    static void RemoveRef(Object*, Document*);
    static void Delete(Object*, Document*);
    static void DeleteDelayed(Object*, Document*);
    static int RefCount(Object*);   
    static int RefId(Object*, Document*);
    static Iterator *MakeDocumentIter(Object*);
    static Iterator *MakeIterator();
    static void CleanUp();
};

#endif

