#include "ET++.h"

#include "BrowserDoc.h"
#include "BrowserCmdNo.h"
#include "Preferences.h"
#include "CLib.h"
#include "Env.h"

//---- BrowserApplication ------------------------------------------------------

class BrowserApplication: public Application { 

public:
    MetaDef(BrowserApplication);
    
    BrowserApplication(int argc, char **argv) : Application(argc, argv, cDocTypeAscii)
	{ }
    Document *DoMakeDocuments(Symbol)
	{ return new BrowserDocument(); }
	void ParseCommandLine(int argc, char **argv);
};

NewMetaImpl0(BrowserApplication,Application);

void BrowserApplication::ParseCommandLine(int argc, char **argv)
{
	char cd[1024];
	strcpy(cd, gSystem->WorkingDirectory());		// why copy in a buffer ?

	for (int i = 1; i < argc; )
	{
		if (argv[i][0] == '-')
		{
			if (argv[i][0] == '-' && argv[i][1] == 's' && (i+1) < argc && strlen(argv[i+1]) > 0){
			    i++; // skip -s option (see main; InitSession())
				i++;
			}
			else
			{
				int n = DoParseOptions(argv[i], argv[i+1]);
				if (n > 0)
					i += n;
				else
					i++;
			}
		}
		else
		{
			gSystem->ChangeDirectory(cd);
			OpenDocument(argv[i++]);
		}
	}
}
//---- main --------------------------------------------------------------------
int main(int argc, char **argv)
{
	ETInitAll( argc, argv );
    return BrowserApplication(argc, argv).Run();
}
