class SWTasks:
	s_begin           = "Begin"
	s_check_env       = "Environment variables"
	s_check_tools     = "Parsers"	
	s_check_licenses  = "Licenses"
	s_check_examples  = "Online documentation"
	s_check_docu      = "Select Tutorial"
	s_select_tutorial = "Example code"
	s_finish          = "Finish"

class SWModel:
	s_tool_sniff	      = "SNiFF+"
	s_tool_cpp            = "C/C++"
	s_tool_java           = "Java"
	s_tool_fortran        = "Fortran"
	s_tool_idl            = "IDL"
	s_installed_examples  = "Example code"
	s_installed_docu	  = "Online documentation"

###################################################################

class SWCheck:
	# The default Check layout 
 
	# generic string, when the check was ok
	s_check_ok			  = "is installed"
	# generic string, when the check had an error
	s_error				  = "Cannot be found!"

	# formats for the non error case
	s_normal_format	      = "@B%s @B"
	s_normal_name_format  = "%s"
	# formats for the error case
	s_error_name_format   = "@B%s@B"
	s_error_format	      = "@B%s@B"

class SWCheckEnvVar(SWCheck):
	# The strings for Envoronment Variable checks
	# Can override the values from SWCheck
	s_check_ok			  = "is set correctly"
	s_error				  = "is not set correctly!"
class SWCheckTool(SWCheck):
	# strings for tools
	#s_check_ok			  = "Tool installed."
	s_error				  = "Cannot be found!"
	s_parser			  = " Parser "

class SWCheckLicense(SWCheck):
	# strings for Licenses
	s_check_ok			  = "Yes"
	s_error				  = "No"
	s_parser			  = " Parser "
class SWCheckFile(SWCheck):
	# strings for Docu/Examples
	s_check_ok			  = "is installed."
	s_error				  = "is not installed! "

###################################################################
class SWPage:
	# Generic values for all pages
	# Concrete pages can override any of the values
	s_name            = ""
	s_help            = ""
	s_header          = ""
	s_explain         = ""
	s_details         = "Details..."
	s_details_html    = "<H1>%(name)s</H1>\n%(details)s"
	s_detail_html     = "<H1>%(name)s</H1>%(info)s"
class SWBeginPage(SWPage):
	s_name="Begin"
	s_header="Welcome to the SNiFF+ Setup Wizard"
	s_explain=(
		"This Setup Wizard checks to see if your SNiFF+ environment "
		"is set correctly. To page through the Wizard, click @BNext@B or click on the relevant information using the task bar on the left. "
	)
	s_alert=(
		"To see this Wizard again, choose @BSetup Info@B from the @BHelp@B menu in the Launch Pad."
	)
	s_dont_show_anymore="Show this Wizard at StartUp."
class SWCheckEnv(SWPage):
	s_name   = "Environment variables"
	s_header = "Environment variables:"
 
	s_details_html    = """
		<H1>Environment variables</H1>
		<Strong>If environment variables aren't set correctly, please refer to the Installation Guide for a detailed description on how to set them correctly. The current settings are:</Strong>
		<DL>%(details)s<DL>
	"""
	s_detail_html     = """
		<DT><strong>%(name)s</strong>
		<DD>%(info)s
	"""
class SWCheckTools(SWPage):
	s_name   = "Parsers"
	s_header="Parsers available:"
	s_details_html = """
		<H1>Parsers</H1>
<DT><strong>The following parser executables are used:</strong><BR>

		%(details)s
<BR><DT><strong>Note: If parsers cannot be found, most probably the PATH environment variable is not set correctly or the parsers have not been installed.</strong>
	"""
	s_detail_html = """
		<H2>%(name)s:</H2>
		<code><H4>%(info)s</H4></code>
			"""
class SWCheckLicenses(SWPage):
	s_name            = "Licenses"
	s_help   = ""
	s_header="You have a license for the following modules:"
	s_details_html    = """
		<H1>%(name)s</H1>
		The following list shows detailed information about your license file
		%(description)s
		<hr>
		%(details)s
	"""

class SWCheckExamples(SWPage):
	s_name   = "Example code"
	s_header="Example code:"
	s_explain="If you want to work through the example tutorials, make sure that the example code is properly installed."
	s_detail_html     = """
		<Strong>By default, the example code is located in the <CODE>$SNIFF_DIR/example</CODE> directory. <BR><BR>If the example code cannot be found, either it hasn't been installed or the installation failed. To install it again, start the installation process and choose the Examples package. </Strong>
	"""
class SWCheckDocu(SWPage):
	s_name   = "Online documentation"
	s_header="Online documentation:"
	s_explain = "To be able to access the online documentation for SNiFF+ and the SNiFF+ tutorials, make sure that the documentation files are properly installed."
	s_detail_html     = """
	<Strong>By default, the documentation files are located in the <CODE>$SNIFF_DIR/doc/online</CODE> directory.<BR><BR>If the documentation files cannot be found, either they haven't been installed or the installation failed. To install them again, start the installation process and choose the Basic SNiFF+ package. </Strong>
	"""
class SWStartTutorial(SWPage):
	s_name    = "Select Tutorial"
	s_header  = "Select which online tutorial you want to read."
	s_explain = ""
	s_which_tutorial = "Which Tutorial?"
	s_no_tutorial    = "None"

class SWFinish(SWPage):
	s_name          = "Finish"
	s_header        = "To close this Wizard press Finish."
	s_explain       = ""
	s_no_tutorial   = ""
	s_show_tutorial = "You will now see the @I%s@I tutorial!"

